<?php 
function DrawBidResults($TurnHistoryID, $con)
{

   // get the players involved in this game and sort by score.
   
   $bids = mysqli_query($con, "SELECT PlayerInGames.TeamName, PlayerInGames.Color, Bids.Rate, Bids.Amount, Bids.Actual, Bids.Sold, Bids.Unsold, Bids.Unmet, Bids.MoneyMade FROM Bids INNER JOIN PlayerInGames WHERE PlayerInGames.PlayerInGameID = Bids.PlayerInGameID AND Bids.TurnHistoryID=$TurnHistoryID ORDER BY Bids.Rate ASC;");
   if (!$bids)
    {
      echo "Error 5: Could not find bid information";
      return;      
    }
    else
    {
      echo "<TABLE CLASS='Standard'><TR>";
      echo "<TH CLASS='Standard'>Player (Ranked)</Th>";
      echo "<TH CLASS='Standard'>Price (\$M/MWh)</Th>";
      echo "<TH CLASS='Standard'>Pledge (MW)</Th>";
      echo "<TH CLASS='Standard'>Actual (MW)</Th>";
      echo "<TH CLASS='Standard'>Sold (MW)</Th>";
      echo "<TH CLASS='Standard'>Unsold (MW)</Th>";
      echo "<TH CLASS='Standard'>Change (\$M)</Th>";
     
      
      echo "</TR>";
      if ($bids->num_rows<=0)
      {
        echo "</TABLE><P>No bids were given in the previous round!";
      }      
      else
      {
        while($bidrow=mysqli_fetch_row($bids))
        {
          echo "<TR>";
        
          echo "<TD CLASS='Standard BGColor" . $bidrow[1] . "' Style='text-align:left;'>" . $bidrow[0] . "</TD>";
          echo "<TD CLASS='Standard' Style='text-align:right;'>" . $bidrow[2] . "</TD>";
          echo "<TD CLASS='Standard' Style='text-align:right;'>" . $bidrow[3] . "</TD>";
          echo "<TD CLASS='Standard' Style='text-align:right;'>" . $bidrow[4] . "</TD>";
          echo "<TD CLASS='Standard' Style='text-align:right;'>" . $bidrow[5] . "</TD>";
          echo "<TD CLASS='Standard' Style='text-align:right;'>" . $bidrow[6] . "</TD>";
          
          echo "<TD CLASS='Standard' Style='text-align:right;'>";
          
          if ($bidrow[8]<0)
          {
            echo "<FONT COLOR='red'>";
          }
          elseif ($bidrow[8]>0)
          {
            echo "<FONT COLOR='green'>+";
          }
          echo $bidrow[8];
          
          if ($bidrow[8]!=0)
          {
            echo "</FONT>";
          }
          
          echo "</TD>";
          
        }
        echo "</TABLE>";     
      }
      
    }

}
?>