-- phpMyAdmin SQL Dump
-- version 4.1.14.8
-- http://www.phpmyadmin.net
--
-- Host: yourhosthere
-- Generation Time: Jun 13, 2018 at 04:27 AM
-- Server version: 5.5.60-0+deb7u1-log
-- PHP Version: 5.4.45-0+deb7u14

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `yourdatabasehere`
--

-- --------------------------------------------------------

--
-- Table structure for table `Bids`
--

CREATE TABLE IF NOT EXISTS `Bids` (
  `BidID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PlayerInGameID` int(10) unsigned NOT NULL,
  `Amount` int(10) unsigned NOT NULL,
  `Rate` double NOT NULL,
  `Turn` int(10) unsigned NOT NULL,
  `Actual` int(10) unsigned NOT NULL,
  `Sold` int(10) unsigned NOT NULL,
  `Unsold` int(10) unsigned NOT NULL,
  `Unmet` int(10) unsigned NOT NULL,
  `TurnHistoryID` int(10) unsigned NOT NULL,
  `MoneyMade` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`BidID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Amount in MW. Rate in $/MWh' AUTO_INCREMENT=1763 ;

-- --------------------------------------------------------

--
-- Table structure for table `DemandForecast`
--

CREATE TABLE IF NOT EXISTS `DemandForecast` (
  `ForecastID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `GameID` int(10) unsigned NOT NULL,
  `S1` smallint(5) unsigned NOT NULL,
  `S2` smallint(5) unsigned NOT NULL,
  `S3` smallint(5) unsigned NOT NULL,
  `S4` smallint(5) unsigned NOT NULL,
  `S5` smallint(5) unsigned NOT NULL,
  `S6` smallint(5) unsigned NOT NULL,
  `S7` smallint(5) unsigned NOT NULL,
  `S8` smallint(5) unsigned NOT NULL,
  `S9` smallint(5) unsigned NOT NULL,
  `S10` smallint(5) unsigned NOT NULL,
  `S11` smallint(5) unsigned NOT NULL,
  `S12` smallint(5) unsigned NOT NULL,
  `S13` smallint(5) unsigned NOT NULL,
  `S14` smallint(5) unsigned NOT NULL,
  `S15` smallint(5) unsigned NOT NULL,
  `S16` smallint(5) unsigned NOT NULL,
  `S17` smallint(5) unsigned NOT NULL,
  `S18` smallint(5) unsigned NOT NULL,
  `S19` smallint(5) unsigned NOT NULL,
  `S20` smallint(5) unsigned NOT NULL,
  `S21` smallint(5) unsigned NOT NULL,
  `S22` smallint(5) unsigned NOT NULL,
  `S23` smallint(5) unsigned NOT NULL,
  `S24` smallint(5) unsigned NOT NULL,
  PRIMARY KEY (`ForecastID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='S 0=sunny, 4=overcast   W: 0=calm 4=stormy' AUTO_INCREMENT=39 ;

-- --------------------------------------------------------

--
-- Table structure for table `GameData`
--

CREATE TABLE IF NOT EXISTS `GameData` (
  `GameDataID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `CoalCapital` double unsigned NOT NULL,
  `CoalOperating` double unsigned NOT NULL,
  `CoalCapacity` int(10) unsigned NOT NULL,
  `GasCapital` double unsigned NOT NULL,
  `GasOperating` double unsigned NOT NULL,
  `GasCapacity` int(10) unsigned NOT NULL,
  `NukeCapital` double unsigned NOT NULL,
  `NukeOperating` double unsigned NOT NULL,
  `NukeCapacity` int(10) unsigned NOT NULL,
  `WindCapital` double unsigned NOT NULL,
  `WindOperating` double unsigned NOT NULL,
  `WindCapacity` int(10) unsigned NOT NULL,
  `SolarCapital` double unsigned NOT NULL,
  `SolarOperating` double unsigned NOT NULL,
  `SolarCapacity` int(10) unsigned NOT NULL,
  `CO2Tax` double unsigned NOT NULL,
  `GameTitle` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `GameDescription` text COLLATE latin1_general_ci NOT NULL,
  `AvgDemand` int(10) unsigned NOT NULL DEFAULT '10000',
  PRIMARY KEY (`GameDataID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=2 ;

--
-- Dumping data for table `GameData`
--

INSERT INTO `GameData` (`GameDataID`, `CoalCapital`, `CoalOperating`, `CoalCapacity`, `GasCapital`, `GasOperating`, `GasCapacity`, `NukeCapital`, `NukeOperating`, `NukeCapacity`, `WindCapital`, `WindOperating`, `WindCapacity`, `SolarCapital`, `SolarOperating`, `SolarCapacity`, `CO2Tax`, `GameTitle`, `GameDescription`, `AvgDemand`) VALUES
(1, 200, 30, 400, 75, 30, 200, 1000, 20, 800, 80, 0, 100, 100, 0, 100, 0, 'Default (No Carbon Taxes)', 'Default pricing for all equipment, no carbon taxes or government incentives.', 9000);

-- --------------------------------------------------------

--
-- Table structure for table `Games`
--

CREATE TABLE IF NOT EXISTS `Games` (
  `GameID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `GMID` int(10) unsigned NOT NULL,
  `Status` tinyint(4) NOT NULL DEFAULT '0',
  `Turn` int(10) unsigned NOT NULL DEFAULT '0',
  `MaxTurns` int(11) NOT NULL DEFAULT '24',
  `MapID` int(10) unsigned NOT NULL,
  `Date` date NOT NULL,
  `Time` int(11) NOT NULL DEFAULT '5',
  `GameDataID` int(10) unsigned NOT NULL,
  `GameTitle` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `MaxPlayers` tinyint(4) NOT NULL DEFAULT '8',
  `Message` text COLLATE latin1_general_ci NOT NULL,
  `StartTime` int(10) unsigned NOT NULL DEFAULT '5',
  `Blackouts` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`GameID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Status values: 0 = setup mode; 1=in progress; 2=completed.  ' AUTO_INCREMENT=38 ;

-- --------------------------------------------------------

--
-- Table structure for table `GMs`
--

CREATE TABLE IF NOT EXISTS `GMs` (
  `GMID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `Username` varchar(20) COLLATE latin1_general_ci NOT NULL,
  `Password` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `ScreenName` varchar(55) COLLATE latin1_general_ci NOT NULL,
  PRIMARY KEY (`GMID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=4 ;

--
-- Dumping data for table `GMs`
--

INSERT INTO `GMs` (`GMID`, `Username`, `Password`, `ScreenName`) VALUES
(1, 'teacher', 'bba7956c7c31e5b3df007f8414c3e290', 'Teacher'),
(2, 'teacher1', 'bba7956c7c31e5b3df007f8414c3e290', 'Teacher 1'),
(3, 'teacher2', 'bba7956c7c31e5b3df007f8414c3e290', 'Teacher 2');

-- --------------------------------------------------------

--
-- Table structure for table `MapData`
--

CREATE TABLE IF NOT EXISTS `MapData` (
  `MapDataID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `MapID` int(10) unsigned NOT NULL,
  `X` smallint(5) unsigned NOT NULL,
  `Y` smallint(5) unsigned NOT NULL,
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BuildPenalty` double NOT NULL DEFAULT '0',
  `Wind` double NOT NULL DEFAULT '3',
  `Sun` double NOT NULL DEFAULT '3',
  `NearestWeatherStationID` int(10) unsigned NOT NULL,
  PRIMARY KEY (`MapDataID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Type: 0=build any, 1=renewable only, 2=no builds' AUTO_INCREMENT=801 ;

--
-- Dumping data for table `MapData`
--

INSERT INTO `MapData` (`MapDataID`, `MapID`, `X`, `Y`, `Type`, `BuildPenalty`, `Wind`, `Sun`, `NearestWeatherStationID`) VALUES
(1, 1, 1, 1, 1, 15, 1, 3, 1),
(2, 1, 2, 1, 1, 14, 1, 2, 1),
(3, 1, 3, 1, 1, 13, 2, 2, 1),
(4, 1, 4, 1, 1, 12, 2, 2, 1),
(5, 1, 5, 1, 1, 11, 4, 2, 1),
(6, 1, 6, 1, 0, 10, 5, 2, 1),
(7, 1, 7, 1, 2, 3, 5, 3, 1),
(8, 1, 8, 1, 2, 3, 5, 3, 1),
(9, 1, 9, 1, 0, 32, 5, 2, 1),
(10, 1, 10, 1, 1, 31, 5, 3, 1),
(11, 1, 11, 1, 1, 30, 5, 4, 1),
(12, 1, 12, 1, 1, 29, 5, 3, 1),
(13, 1, 13, 1, 1, 28, 5, 2, 1),
(14, 1, 14, 1, 0, 28, 5, 3, 4),
(15, 1, 15, 1, 1, 27, 4, 3, 4),
(16, 1, 16, 1, 1, 27, 2, 3, 4),
(17, 1, 17, 1, 1, 26, 3, 3, 4),
(18, 1, 18, 1, 1, 27, 3, 3, 4),
(19, 1, 19, 1, 1, 27, 4, 3, 4),
(20, 1, 20, 1, 1, 27, 4, 3, 4),
(21, 1, 1, 2, 1, 15, 1, 3, 1),
(22, 1, 2, 2, 1, 13, 1, 3, 1),
(23, 1, 3, 2, 1, 13, 1, 2, 1),
(24, 1, 4, 2, 1, 11, 1, 2, 1),
(25, 1, 5, 2, 1, 10, 4, 2, 1),
(26, 1, 6, 2, 1, 10, 5, 2, 1),
(27, 1, 7, 2, 0, 9, 5, 4, 1),
(28, 1, 8, 2, 0, 8, 5, 4, 1),
(29, 1, 9, 2, 2, 3, 5, 3, 1),
(30, 1, 10, 2, 2, 3, 5, 3, 1),
(31, 1, 11, 2, 2, 3, 5, 3, 1),
(32, 1, 12, 2, 2, 3, 5, 3, 1),
(33, 1, 13, 2, 2, 3, 5, 2, 1),
(34, 1, 14, 2, 0, 27, 5, 3, 4),
(35, 1, 15, 2, 1, 26, 4, 3, 4),
(36, 1, 16, 2, 1, 26, 4, 3, 4),
(37, 1, 17, 2, 1, 25, 4, 2, 4),
(38, 1, 18, 2, 1, 26, 4, 1, 4),
(39, 1, 19, 2, 1, 26, 4, 2, 4),
(40, 1, 20, 2, 0, 7, 2, 2, 4),
(41, 1, 1, 3, 1, 14, 1, 3, 1),
(42, 1, 2, 3, 1, 13, 1, 3, 1),
(43, 1, 3, 3, 1, 12, 1, 3, 1),
(44, 1, 4, 3, 1, 11, 1, 3, 1),
(45, 1, 5, 3, 1, 10, 4, 3, 1),
(46, 1, 6, 3, 1, 9, 4, 3, 1),
(47, 1, 7, 3, 0, 8, 4, 2, 1),
(48, 1, 8, 3, 0, 7, 5, 4, 1),
(49, 1, 9, 3, 2, 3, 5, 3, 1),
(50, 1, 10, 3, 2, 3, 5, 3, 1),
(51, 1, 11, 3, 2, 3, 5, 3, 1),
(52, 1, 12, 3, 2, 3, 5, 3, 1),
(53, 1, 13, 3, 2, 3, 5, 3, 1),
(54, 1, 14, 3, 0, 26, 4, 3, 4),
(55, 1, 15, 3, 0, 26, 4, 4, 4),
(56, 1, 16, 3, 0, 25, 4, 4, 4),
(57, 1, 17, 3, 1, 25, 4, 1, 4),
(58, 1, 18, 3, 0, 25, 4, 1, 4),
(59, 1, 19, 3, 0, 6, 3, 1, 4),
(60, 1, 20, 3, 0, 6, 3, 1, 4),
(61, 1, 1, 4, 1, 14, 1, 3, 1),
(62, 1, 2, 4, 1, 12, 1, 3, 1),
(63, 1, 3, 4, 0, 12, 2, 3, 1),
(64, 1, 4, 4, 1, 10, 2, 3, 1),
(65, 1, 5, 4, 1, 9, 1, 3, 1),
(66, 1, 6, 4, 1, 9, 1, 3, 1),
(67, 1, 7, 4, 0, 8, 4, 2, 1),
(68, 1, 8, 4, 0, 7, 5, 4, 1),
(69, 1, 9, 4, 2, 3, 5, 3, 1),
(70, 1, 10, 4, 2, 3, 5, 4, 1),
(71, 1, 11, 4, 2, 3, 5, 3, 1),
(72, 1, 12, 4, 2, 3, 5, 3, 1),
(73, 1, 13, 4, 2, 3, 5, 3, 1),
(74, 1, 14, 4, 2, 3, 4, 2, 4),
(75, 1, 15, 4, 2, 3, 4, 2, 4),
(76, 1, 16, 4, 2, 3, 4, 2, 4),
(77, 1, 17, 4, 0, 5, 4, 1, 4),
(78, 1, 18, 4, 1, 5, 3, 1, 4),
(79, 1, 19, 4, 0, 5, 3, 2, 4),
(80, 1, 20, 4, 0, 6, 4, 1, 4),
(81, 1, 1, 5, 1, 14, 1, 3, 1),
(82, 1, 2, 5, 1, 12, 2, 3, 1),
(83, 1, 3, 5, 1, 11, 2, 3, 1),
(84, 1, 4, 5, 1, 10, 2, 3, 1),
(85, 1, 5, 5, 1, 9, 1, 3, 1),
(86, 1, 6, 5, 1, 9, 4, 3, 1),
(87, 1, 7, 5, 0, 8, 5, 2, 1),
(88, 1, 8, 5, 0, 7, 5, 4, 1),
(89, 1, 9, 5, 0, 6, 5, 4, 1),
(90, 1, 10, 5, 2, 3, 5, 3, 1),
(91, 1, 11, 5, 2, 3, 5, 3, 1),
(92, 1, 12, 5, 2, 3, 5, 3, 1),
(93, 1, 13, 5, 0, 4, 5, 2, 4),
(94, 1, 14, 5, 0, 4, 5, 3, 4),
(95, 1, 15, 5, 0, 4, 5, 1, 4),
(96, 1, 16, 5, 0, 4, 4, 1, 4),
(97, 1, 17, 5, 1, 4, 4, 1, 4),
(98, 1, 18, 5, 0, 4, 4, 1, 4),
(99, 1, 19, 5, 0, 4, 4, 2, 4),
(100, 1, 20, 5, 2, 3, 4, 1, 4),
(101, 1, 1, 6, 1, 13, 1, 3, 1),
(102, 1, 2, 6, 1, 12, 1, 3, 1),
(103, 1, 3, 6, 1, 11, 1, 3, 1),
(104, 1, 4, 6, 0, 10, 1, 3, 1),
(105, 1, 5, 6, 1, 9, 1, 3, 1),
(106, 1, 6, 6, 1, 9, 4, 3, 1),
(107, 1, 7, 6, 0, 8, 5, 2, 1),
(108, 1, 8, 6, 2, 3, 5, 4, 1),
(109, 1, 9, 6, 2, 3, 5, 2, 1),
(110, 1, 10, 6, 0, 5, 5, 3, 1),
(111, 1, 11, 6, 0, 4, 5, 3, 1),
(112, 1, 12, 6, 0, 4, 5, 4, 4),
(113, 1, 13, 6, 1, 4, 5, 2, 4),
(114, 1, 14, 6, 1, 3, 2, 2, 4),
(115, 1, 15, 6, 1, 3, 1, 2, 4),
(116, 1, 16, 6, 1, 3, 1, 2, 4),
(117, 1, 17, 6, 1, 3, 2, 2, 4),
(118, 1, 18, 6, 0, 3, 4, 2, 4),
(119, 1, 19, 6, 2, 3, 4, 3, 4),
(120, 1, 20, 6, 2, 3, 4, 2, 4),
(121, 1, 1, 7, 1, 12, 1, 3, 1),
(122, 1, 2, 7, 1, 11, 1, 3, 1),
(123, 1, 3, 7, 1, 11, 1, 3, 1),
(124, 1, 4, 7, 1, 10, 1, 3, 1),
(125, 1, 5, 7, 0, 9, 1, 3, 1),
(126, 1, 6, 7, 1, 9, 4, 3, 1),
(127, 1, 7, 7, 0, 8, 5, 2, 1),
(128, 1, 8, 7, 2, 3, 5, 2, 1),
(129, 1, 9, 7, 2, 3, 5, 2, 1),
(130, 1, 10, 7, 2, 3, 5, 3, 1),
(131, 1, 11, 7, 0, 4, 5, 3, 4),
(132, 1, 12, 7, 0, 3, 2, 5, 4),
(133, 1, 13, 7, 1, 3, 2, 4, 4),
(134, 1, 14, 7, 1, 3, 2, 4, 4),
(135, 1, 15, 7, 1, 2, 1, 3, 4),
(136, 1, 16, 7, 1, 2, 1, 2, 4),
(137, 1, 17, 7, 1, 2, 1, 2, 4),
(138, 1, 18, 7, 0, 2, 4, 3, 4),
(139, 1, 19, 7, 2, 3, 4, 2, 4),
(140, 1, 20, 7, 2, 3, 4, 2, 4),
(141, 1, 1, 8, 1, 12, 1, 3, 1),
(142, 1, 2, 8, 1, 11, 1, 3, 1),
(143, 1, 3, 8, 1, 10, 1, 3, 1),
(144, 1, 4, 8, 1, 10, 1, 3, 1),
(145, 1, 5, 8, 1, 9, 1, 3, 1),
(146, 1, 6, 8, 1, 9, 4, 3, 1),
(147, 1, 7, 8, 0, 8, 5, 2, 1),
(148, 1, 8, 8, 0, 7, 5, 2, 1),
(149, 1, 9, 8, 0, 6, 5, 2, 1),
(150, 1, 10, 8, 2, 3, 5, 3, 4),
(151, 1, 11, 8, 2, 3, 5, 3, 4),
(152, 1, 12, 8, 0, 3, 5, 5, 4),
(153, 1, 13, 8, 1, 2, 3, 4, 4),
(154, 1, 14, 8, 1, 2, 2, 2, 4),
(155, 1, 15, 8, 1, 2, 1, 2, 4),
(156, 1, 16, 8, 1, 1, 1, 2, 4),
(157, 1, 17, 8, 1, 1, 1, 2, 4),
(158, 1, 18, 8, 0, 1, 4, 2, 4),
(159, 1, 19, 8, 2, 3, 4, 2, 4),
(160, 1, 20, 8, 2, 3, 4, 2, 4),
(161, 1, 1, 9, 1, 12, 1, 3, 1),
(162, 1, 2, 9, 1, 11, 1, 3, 1),
(163, 1, 3, 9, 1, 10, 1, 3, 1),
(164, 1, 4, 9, 0, 9, 1, 3, 1),
(165, 1, 5, 9, 1, 9, 1, 3, 1),
(166, 1, 6, 9, 0, 9, 4, 3, 1),
(167, 1, 7, 9, 0, 8, 4, 2, 1),
(168, 1, 8, 9, 1, 7, 4, 3, 1),
(169, 1, 9, 9, 0, 6, 5, 2, 4),
(170, 1, 10, 9, 0, 5, 5, 2, 4),
(171, 1, 11, 9, 0, 4, 5, 3, 4),
(172, 1, 12, 9, 0, 3, 5, 4, 4),
(173, 1, 13, 9, 1, 2, 1, 2, 4),
(174, 1, 14, 9, 1, 1, 1, 2, 4),
(175, 1, 15, 9, 1, 1, 1, 2, 4),
(176, 1, 16, 9, 0, 1, 2, 2, 4),
(177, 1, 17, 9, 3, 0, 3, 3, 4),
(178, 1, 18, 9, 0, 1, 4, 3, 4),
(179, 1, 19, 9, 2, 3, 4, 1, 4),
(180, 1, 20, 9, 0, 23, 3, 1, 4),
(181, 1, 1, 10, 1, 12, 1, 3, 1),
(182, 1, 2, 10, 1, 11, 1, 3, 1),
(183, 1, 3, 10, 1, 10, 1, 3, 1),
(184, 1, 4, 10, 1, 9, 1, 3, 1),
(185, 1, 5, 10, 1, 8, 1, 3, 1),
(186, 1, 6, 10, 0, 8, 1, 3, 1),
(187, 1, 7, 10, 0, 7, 1, 2, 1),
(188, 1, 8, 10, 1, 7, 1, 2, 4),
(189, 1, 9, 10, 1, 6, 1, 2, 4),
(190, 1, 10, 10, 1, 5, 1, 2, 4),
(191, 1, 11, 10, 1, 4, 1, 3, 4),
(192, 1, 12, 10, 0, 3, 1, 3, 4),
(193, 1, 13, 10, 0, 2, 1, 2, 4),
(194, 1, 14, 10, 1, 1, 1, 3, 4),
(195, 1, 15, 10, 3, 0, 3, 3, 4),
(196, 1, 16, 10, 2, 3, 3, 1, 4),
(197, 1, 17, 10, 1, 1, 4, 2, 4),
(198, 1, 18, 10, 0, 1, 3, 3, 4),
(199, 1, 19, 10, 0, 22, 3, 1, 4),
(200, 1, 20, 10, 0, 23, 2, 2, 4),
(201, 1, 1, 11, 1, 19, 1, 3, 1),
(202, 1, 2, 11, 1, 17, 1, 3, 1),
(203, 1, 3, 11, 1, 16, 1, 3, 1),
(204, 1, 4, 11, 0, 16, 1, 3, 1),
(205, 1, 5, 11, 1, 8, 1, 2, 1),
(206, 1, 6, 11, 1, 7, 3, 2, 1),
(207, 1, 7, 11, 1, 7, 2, 2, 1),
(208, 1, 8, 11, 1, 6, 2, 2, 3),
(209, 1, 9, 11, 1, 6, 2, 3, 3),
(210, 1, 10, 11, 1, 5, 2, 1, 4),
(211, 1, 11, 11, 1, 4, 1, 3, 4),
(212, 1, 12, 11, 0, 3, 1, 2, 4),
(213, 1, 13, 11, 1, 2, 1, 3, 4),
(214, 1, 14, 11, 0, 1, 1, 2, 4),
(215, 1, 15, 11, 2, 3, 3, 2, 4),
(216, 1, 16, 11, 2, 3, 2, 2, 4),
(217, 1, 17, 11, 1, 2, 2, 2, 4),
(218, 1, 18, 11, 0, 22, 4, 3, 4),
(219, 1, 19, 11, 1, 22, 2, 2, 4),
(220, 1, 20, 11, 1, 23, 1, 1, 4),
(221, 1, 1, 12, 1, 18, 1, 3, 1),
(222, 1, 2, 12, 0, 17, 1, 3, 1),
(223, 1, 3, 12, 1, 16, 1, 3, 1),
(224, 1, 4, 12, 1, 15, 1, 3, 1),
(225, 1, 5, 12, 1, 15, 1, 2, 1),
(226, 1, 6, 12, 1, 7, 1, 2, 1),
(227, 1, 7, 12, 1, 6, 1, 2, 3),
(228, 1, 8, 12, 1, 5, 3, 2, 3),
(229, 1, 9, 12, 1, 5, 3, 3, 3),
(230, 1, 10, 12, 1, 5, 2, 1, 3),
(231, 1, 11, 12, 1, 4, 1, 3, 4),
(232, 1, 12, 12, 1, 3, 1, 2, 4),
(233, 1, 13, 12, 1, 2, 1, 3, 4),
(234, 1, 14, 12, 0, 2, 3, 2, 4),
(235, 1, 15, 12, 2, 3, 4, 2, 4),
(236, 1, 16, 12, 0, 22, 4, 1, 4),
(237, 1, 17, 12, 1, 22, 4, 2, 4),
(238, 1, 18, 12, 1, 23, 3, 3, 4),
(239, 1, 19, 12, 1, 23, 2, 2, 4),
(240, 1, 20, 12, 1, 24, 1, 2, 4),
(241, 1, 1, 13, 1, 18, 1, 3, 3),
(242, 1, 2, 13, 1, 17, 1, 3, 3),
(243, 1, 3, 13, 1, 16, 1, 3, 3),
(244, 1, 4, 13, 1, 15, 1, 3, 3),
(245, 1, 5, 13, 1, 14, 1, 2, 3),
(246, 1, 6, 13, 1, 14, 1, 2, 3),
(247, 1, 7, 13, 1, 14, 1, 2, 3),
(248, 1, 8, 13, 1, 4, 1, 2, 3),
(249, 1, 9, 13, 1, 4, 3, 2, 3),
(250, 1, 10, 13, 1, 4, 2, 2, 3),
(251, 1, 11, 13, 1, 4, 1, 2, 3),
(252, 1, 12, 13, 0, 3, 1, 2, 4),
(253, 1, 13, 13, 1, 3, 1, 2, 4),
(254, 1, 14, 13, 0, 3, 3, 2, 4),
(255, 1, 15, 13, 2, 3, 4, 2, 4),
(256, 1, 16, 13, 0, 23, 4, 2, 4),
(257, 1, 17, 13, 1, 23, 2, 2, 4),
(258, 1, 18, 13, 1, 24, 2, 2, 4),
(259, 1, 19, 13, 1, 24, 1, 3, 4),
(260, 1, 20, 13, 1, 25, 1, 2, 4),
(261, 1, 1, 14, 1, 18, 1, 3, 3),
(262, 1, 2, 14, 0, 17, 1, 2, 3),
(263, 1, 3, 14, 1, 16, 2, 2, 3),
(264, 1, 4, 14, 1, 15, 1, 2, 3),
(265, 1, 5, 14, 1, 14, 1, 4, 3),
(266, 1, 6, 14, 1, 13, 1, 4, 3),
(267, 1, 7, 14, 1, 13, 1, 4, 3),
(268, 1, 8, 14, 1, 3, 1, 4, 3),
(269, 1, 9, 14, 1, 3, 1, 4, 3),
(270, 1, 10, 14, 1, 3, 2, 3, 3),
(271, 1, 11, 14, 1, 3, 1, 3, 3),
(272, 1, 12, 14, 0, 3, 1, 3, 3),
(273, 1, 13, 14, 1, 4, 1, 3, 4),
(274, 1, 14, 14, 0, 4, 3, 3, 4),
(275, 1, 15, 14, 2, 3, 5, 2, 4),
(276, 1, 16, 14, 0, 24, 5, 3, 4),
(277, 1, 17, 14, 1, 24, 2, 4, 5),
(278, 1, 18, 14, 1, 25, 1, 3, 5),
(279, 1, 19, 14, 0, 25, 1, 3, 5),
(280, 1, 20, 14, 1, 26, 1, 3, 5),
(281, 1, 1, 15, 1, 18, 1, 3, 3),
(282, 1, 2, 15, 0, 17, 1, 2, 3),
(283, 1, 3, 15, 1, 16, 1, 2, 3),
(284, 1, 4, 15, 1, 15, 1, 2, 3),
(285, 1, 5, 15, 1, 14, 1, 2, 3),
(286, 1, 6, 15, 1, 13, 1, 4, 3),
(287, 1, 7, 15, 1, 12, 1, 4, 3),
(288, 1, 8, 15, 1, 2, 1, 4, 3),
(289, 1, 9, 15, 1, 2, 1, 4, 3),
(290, 1, 10, 15, 1, 2, 1, 4, 3),
(291, 1, 11, 15, 1, 2, 1, 4, 3),
(292, 1, 12, 15, 1, 3, 1, 4, 3),
(293, 1, 13, 15, 0, 4, 4, 4, 3),
(294, 1, 14, 15, 0, 5, 3, 4, 4),
(295, 1, 15, 15, 2, 3, 4, 2, 4),
(296, 1, 16, 15, 0, 25, 4, 3, 5),
(297, 1, 17, 15, 1, 25, 2, 4, 5),
(298, 1, 18, 15, 0, 26, 1, 3, 5),
(299, 1, 19, 15, 1, 26, 1, 3, 5),
(300, 1, 20, 15, 1, 27, 1, 3, 5),
(301, 1, 1, 16, 1, 18, 1, 3, 3),
(302, 1, 2, 16, 0, 17, 1, 3, 3),
(303, 1, 3, 16, 0, 16, 1, 5, 3),
(304, 1, 4, 16, 1, 15, 1, 2, 3),
(305, 1, 5, 16, 1, 14, 1, 4, 3),
(306, 1, 6, 16, 1, 13, 1, 4, 3),
(307, 1, 7, 16, 1, 12, 1, 4, 3),
(308, 1, 8, 16, 1, 1, 1, 4, 3),
(309, 1, 9, 16, 1, 1, 1, 3, 3),
(310, 1, 10, 16, 1, 1, 1, 3, 3),
(311, 1, 11, 16, 1, 2, 1, 4, 3),
(312, 1, 12, 16, 1, 3, 1, 4, 3),
(313, 1, 13, 16, 0, 4, 3, 4, 3),
(314, 1, 14, 16, 2, 3, 3, 4, 5),
(315, 1, 15, 16, 2, 3, 4, 3, 5),
(316, 1, 16, 16, 0, 26, 4, 3, 5),
(317, 1, 17, 16, 1, 26, 3, 3, 5),
(318, 1, 18, 16, 0, 27, 1, 3, 5),
(319, 1, 19, 16, 1, 27, 1, 3, 5),
(320, 1, 20, 16, 1, 28, 1, 3, 5),
(321, 1, 1, 17, 1, 18, 1, 3, 3),
(322, 1, 2, 17, 1, 17, 1, 4, 3),
(323, 1, 3, 17, 1, 16, 1, 5, 3),
(324, 1, 4, 17, 1, 15, 2, 5, 3),
(325, 1, 5, 17, 1, 14, 1, 3, 3),
(326, 1, 6, 17, 1, 13, 1, 4, 3),
(327, 1, 7, 17, 1, 12, 1, 4, 3),
(328, 1, 8, 17, 1, 11, 1, 4, 3),
(329, 1, 9, 17, 3, 0, 3, 3, 3),
(330, 1, 10, 17, 1, 1, 1, 3, 3),
(331, 1, 11, 17, 1, 2, 1, 4, 3),
(332, 1, 12, 17, 1, 3, 1, 4, 3),
(333, 1, 13, 17, 0, 4, 3, 4, 3),
(334, 1, 14, 17, 0, 25, 3, 4, 5),
(335, 1, 15, 17, 0, 26, 3, 3, 5),
(336, 1, 16, 17, 1, 26, 4, 2, 5),
(337, 1, 17, 17, 1, 27, 2, 2, 5),
(338, 1, 18, 17, 1, 28, 1, 2, 5),
(339, 1, 19, 17, 1, 28, 1, 2, 5),
(340, 1, 20, 17, 1, 29, 1, 2, 5),
(341, 1, 1, 18, 1, 18, 1, 3, 3),
(342, 1, 2, 18, 1, 17, 2, 4, 3),
(343, 1, 3, 18, 1, 16, 1, 4, 3),
(344, 1, 4, 18, 0, 15, 1, 4, 3),
(345, 1, 5, 18, 0, 14, 1, 2, 3),
(346, 1, 6, 18, 1, 13, 1, 4, 3),
(347, 1, 7, 18, 0, 12, 1, 4, 3),
(348, 1, 8, 18, 1, 11, 1, 4, 3),
(349, 1, 9, 18, 1, 1, 1, 4, 3),
(350, 1, 10, 18, 1, 1, 1, 3, 3),
(351, 1, 11, 18, 1, 2, 1, 3, 3),
(352, 1, 12, 18, 0, 3, 1, 3, 3),
(353, 1, 13, 18, 1, 24, 1, 3, 5),
(354, 1, 14, 18, 1, 25, 2, 3, 5),
(355, 1, 15, 18, 1, 26, 2, 3, 5),
(356, 1, 16, 18, 1, 27, 2, 2, 5),
(357, 1, 17, 18, 1, 28, 2, 2, 5),
(358, 1, 18, 18, 1, 29, 1, 3, 5),
(359, 1, 19, 18, 1, 29, 1, 4, 5),
(360, 1, 20, 18, 1, 30, 1, 3, 5),
(361, 1, 1, 19, 1, 18, 1, 3, 3),
(362, 1, 2, 19, 1, 17, 1, 4, 3),
(363, 1, 3, 19, 1, 16, 1, 4, 3),
(364, 1, 4, 19, 1, 15, 1, 5, 3),
(365, 1, 5, 19, 1, 14, 1, 3, 3),
(366, 1, 6, 19, 1, 13, 2, 3, 3),
(367, 1, 7, 19, 1, 12, 1, 5, 3),
(368, 1, 8, 19, 1, 12, 1, 4, 3),
(369, 1, 9, 19, 1, 2, 2, 4, 3),
(370, 1, 10, 19, 1, 2, 2, 4, 3),
(371, 1, 11, 19, 1, 2, 1, 4, 3),
(372, 1, 12, 19, 1, 23, 1, 5, 3),
(373, 1, 13, 19, 1, 24, 1, 4, 5),
(374, 1, 14, 19, 1, 25, 2, 3, 5),
(375, 1, 15, 19, 1, 26, 2, 3, 5),
(376, 1, 16, 19, 1, 27, 2, 1, 5),
(377, 1, 17, 19, 1, 28, 1, 1, 5),
(378, 1, 18, 19, 1, 29, 1, 3, 5),
(379, 1, 19, 19, 1, 30, 1, 5, 5),
(380, 1, 20, 19, 1, 31, 1, 4, 5),
(381, 1, 1, 20, 1, 18, 1, 3, 3),
(382, 1, 2, 20, 1, 17, 1, 3, 3),
(383, 1, 3, 20, 1, 16, 1, 3, 3),
(384, 1, 4, 20, 1, 15, 2, 3, 3),
(385, 1, 5, 20, 1, 14, 1, 3, 3),
(386, 1, 6, 20, 1, 13, 1, 2, 3),
(387, 1, 7, 20, 1, 13, 1, 3, 3),
(388, 1, 8, 20, 1, 13, 1, 4, 3),
(389, 1, 9, 20, 1, 3, 1, 4, 3),
(390, 1, 10, 20, 1, 3, 1, 4, 3),
(391, 1, 11, 20, 1, 23, 1, 5, 3),
(392, 1, 12, 20, 1, 24, 1, 5, 3),
(393, 1, 13, 20, 1, 24, 1, 4, 5),
(394, 1, 14, 20, 1, 25, 1, 3, 5),
(395, 1, 15, 20, 1, 27, 1, 3, 5),
(396, 1, 16, 20, 1, 28, 1, 2, 5),
(397, 1, 17, 20, 1, 29, 1, 2, 5),
(398, 1, 18, 20, 1, 30, 1, 1, 5),
(399, 1, 19, 20, 1, 31, 1, 2, 5),
(400, 1, 20, 20, 1, 32, 1, 2, 5),
(401, 2, 1, 1, 1, 26, 2, 4, 6),
(402, 2, 1, 2, 1, 25, 2, 4, 6),
(403, 2, 1, 3, 1, 24, 2, 4, 6),
(404, 2, 1, 4, 1, 23, 3, 4, 6),
(405, 2, 1, 5, 1, 22, 4, 4, 6),
(406, 2, 1, 6, 1, 21, 4, 4, 6),
(407, 2, 1, 7, 1, 21, 3, 4, 6),
(408, 2, 1, 8, 0, 21, 3, 4, 6),
(409, 2, 1, 9, 0, 22, 3, 4, 6),
(410, 2, 1, 10, 1, 23, 4, 4, 6),
(411, 2, 1, 11, 0, 24, 1, 4, 6),
(412, 2, 1, 12, 0, 25, 2, 3, 6),
(413, 2, 1, 13, 1, 26, 2, 4, 6),
(414, 2, 1, 14, 1, 27, 3, 3, 7),
(415, 2, 1, 15, 0, 25, 3, 3, 7),
(416, 2, 1, 16, 1, 24, 3, 2, 7),
(417, 2, 1, 17, 1, 23, 4, 3, 7),
(418, 2, 1, 18, 0, 22, 4, 2, 7),
(419, 2, 1, 19, 1, 22, 3, 2, 7),
(420, 2, 1, 20, 1, 22, 4, 2, 7),
(421, 2, 2, 1, 1, 6, 1, 4, 6),
(422, 2, 2, 2, 1, 5, 2, 4, 6),
(423, 2, 2, 3, 1, 4, 1, 4, 6),
(424, 2, 2, 4, 1, 3, 1, 4, 6),
(425, 2, 2, 5, 1, 2, 4, 4, 6),
(426, 2, 2, 6, 1, 1, 3, 4, 6),
(427, 2, 2, 7, 3, 0, 3, 4, 6),
(428, 2, 2, 8, 1, 21, 3, 4, 6),
(429, 2, 2, 9, 0, 22, 3, 4, 6),
(430, 2, 2, 10, 0, 23, 4, 4, 6),
(431, 2, 2, 11, 1, 24, 3, 4, 6),
(432, 2, 2, 12, 1, 25, 3, 3, 6),
(433, 2, 2, 13, 0, 26, 3, 4, 6),
(434, 2, 2, 14, 0, 26, 3, 3, 7),
(435, 2, 2, 15, 0, 25, 3, 3, 7),
(436, 2, 2, 16, 0, 23, 4, 2, 7),
(437, 2, 2, 17, 1, 22, 4, 2, 7),
(438, 2, 2, 18, 1, 21, 4, 3, 7),
(439, 2, 2, 19, 0, 21, 4, 3, 7),
(440, 2, 2, 20, 1, 21, 4, 3, 7),
(441, 2, 3, 1, 1, 6, 2, 4, 6),
(442, 2, 3, 2, 1, 5, 2, 4, 6),
(443, 2, 3, 3, 1, 4, 1, 4, 6),
(444, 2, 3, 4, 1, 3, 1, 4, 6),
(445, 2, 3, 5, 1, 2, 3, 4, 6),
(446, 2, 3, 6, 1, 1, 3, 4, 6),
(447, 2, 3, 7, 1, 1, 4, 4, 6),
(448, 2, 3, 8, 1, 21, 3, 4, 6),
(449, 2, 3, 9, 1, 22, 3, 4, 6),
(450, 2, 3, 10, 1, 23, 3, 4, 6),
(451, 2, 3, 11, 0, 24, 3, 4, 6),
(452, 2, 3, 12, 1, 25, 3, 4, 6),
(453, 2, 3, 13, 1, 26, 3, 4, 7),
(454, 2, 3, 14, 0, 25, 4, 3, 7),
(455, 2, 3, 15, 1, 24, 4, 2, 7),
(456, 2, 3, 16, 0, 23, 3, 2, 7),
(457, 2, 3, 17, 0, 22, 5, 2, 7),
(458, 2, 3, 18, 0, 21, 4, 3, 7),
(459, 2, 3, 19, 3, 0, 3, 2, 7),
(460, 2, 3, 20, 0, 21, 4, 3, 7),
(461, 2, 4, 1, 1, 6, 2, 4, 6),
(462, 2, 4, 2, 1, 5, 2, 4, 6),
(463, 2, 4, 3, 1, 4, 1, 4, 6),
(464, 2, 4, 4, 1, 3, 1, 4, 6),
(465, 2, 4, 5, 1, 2, 3, 4, 6),
(466, 2, 4, 6, 1, 2, 3, 5, 6),
(467, 2, 4, 7, 0, 2, 5, 5, 6),
(468, 2, 4, 8, 1, 2, 3, 4, 6),
(469, 2, 4, 9, 1, 22, 3, 4, 6),
(470, 2, 4, 10, 1, 3, 3, 4, 6),
(471, 2, 4, 11, 1, 4, 4, 4, 6),
(472, 2, 4, 12, 1, 25, 3, 4, 6),
(473, 2, 4, 13, 1, 26, 4, 4, 7),
(474, 2, 4, 14, 1, 25, 4, 3, 7),
(475, 2, 4, 15, 0, 24, 4, 2, 7),
(476, 2, 4, 16, 0, 23, 5, 2, 7),
(477, 2, 4, 17, 0, 22, 5, 2, 7),
(478, 2, 4, 18, 2, 1, 3, 3, 7),
(479, 2, 4, 19, 2, 1, 3, 3, 7),
(480, 2, 4, 20, 2, 1, 3, 3, 7),
(481, 2, 5, 1, 0, 7, 3, 4, 6),
(482, 2, 5, 2, 0, 5, 3, 4, 6),
(483, 2, 5, 3, 0, 4, 3, 4, 6),
(484, 2, 5, 4, 1, 3, 2, 4, 6),
(485, 2, 5, 5, 1, 3, 1, 4, 6),
(486, 2, 5, 6, 1, 3, 3, 5, 6),
(487, 2, 5, 7, 0, 3, 3, 5, 6),
(488, 2, 5, 8, 1, 3, 2, 4, 6),
(489, 2, 5, 9, 1, 3, 3, 4, 6),
(490, 2, 5, 10, 1, 3, 3, 4, 6),
(491, 2, 5, 11, 1, 4, 4, 4, 6),
(492, 2, 5, 12, 1, 5, 5, 4, 6),
(493, 2, 5, 13, 1, 26, 3, 4, 7),
(494, 2, 5, 14, 1, 25, 3, 3, 7),
(495, 2, 5, 15, 0, 24, 4, 2, 7),
(496, 2, 5, 16, 2, 3, 3, 3, 7),
(497, 2, 5, 17, 2, 2, 3, 3, 7),
(498, 2, 5, 18, 2, 2, 3, 3, 7),
(499, 2, 5, 19, 2, 2, 3, 3, 7),
(500, 2, 5, 20, 2, 2, 3, 3, 7),
(501, 2, 6, 1, 2, 4, 3, 3, 8),
(502, 2, 6, 2, 2, 5, 3, 3, 8),
(503, 2, 6, 3, 0, 4, 3, 4, 8),
(504, 2, 6, 4, 0, 4, 3, 4, 8),
(505, 2, 6, 5, 1, 4, 2, 4, 8),
(506, 2, 6, 6, 1, 4, 1, 4, 8),
(507, 2, 6, 7, 1, 4, 2, 4, 6),
(508, 2, 6, 8, 1, 4, 2, 4, 6),
(509, 2, 6, 9, 1, 4, 3, 5, 6),
(510, 2, 6, 10, 1, 4, 3, 4, 6),
(511, 2, 6, 11, 1, 4, 3, 4, 6),
(512, 2, 6, 12, 0, 5, 3, 4, 9),
(513, 2, 6, 13, 1, 26, 3, 4, 7),
(514, 2, 6, 14, 1, 25, 3, 3, 7),
(515, 2, 6, 15, 0, 25, 4, 2, 7),
(516, 2, 6, 16, 2, 4, 3, 3, 7),
(517, 2, 6, 17, 2, 3, 3, 3, 7),
(518, 2, 6, 18, 2, 3, 3, 3, 7),
(519, 2, 6, 19, 2, 3, 3, 3, 7),
(520, 2, 6, 20, 2, 3, 3, 3, 7),
(521, 2, 7, 1, 0, 7, 5, 3, 8),
(522, 2, 7, 2, 2, 4, 3, 3, 8),
(523, 2, 7, 3, 2, 3, 3, 3, 8),
(524, 2, 7, 4, 0, 3, 3, 4, 8),
(525, 2, 7, 5, 0, 3, 3, 4, 8),
(526, 2, 7, 6, 1, 3, 2, 4, 8),
(527, 2, 7, 7, 1, 3, 1, 5, 8),
(528, 2, 7, 8, 1, 3, 3, 5, 8),
(529, 2, 7, 9, 1, 3, 3, 5, 8),
(530, 2, 7, 10, 1, 5, 4, 4, 8),
(531, 2, 7, 11, 1, 6, 4, 4, 8),
(532, 2, 7, 12, 1, 7, 3, 4, 9),
(533, 2, 7, 13, 0, 7, 3, 4, 9),
(534, 2, 7, 14, 1, 27, 3, 3, 7),
(535, 2, 7, 15, 0, 26, 4, 2, 7),
(536, 2, 7, 16, 2, 5, 3, 3, 7),
(537, 2, 7, 17, 2, 4, 3, 3, 7),
(538, 2, 7, 18, 2, 3, 3, 3, 7),
(539, 2, 7, 19, 2, 3, 3, 3, 7),
(540, 2, 7, 20, 2, 3, 3, 3, 7),
(541, 2, 8, 1, 0, 6, 4, 4, 8),
(542, 2, 8, 2, 0, 0, 3, 3, 8),
(543, 2, 8, 3, 2, 3, 3, 3, 8),
(544, 2, 8, 4, 2, 2, 3, 3, 8),
(545, 2, 8, 5, 0, 2, 3, 4, 8),
(546, 2, 8, 6, 0, 2, 2, 4, 8),
(547, 2, 8, 7, 1, 2, 1, 4, 8),
(548, 2, 8, 8, 1, 2, 2, 5, 8),
(549, 2, 8, 9, 1, 3, 3, 5, 8),
(550, 2, 8, 10, 1, 4, 4, 5, 8),
(551, 2, 8, 11, 1, 5, 3, 4, 8),
(552, 2, 8, 12, 1, 6, 2, 4, 9),
(553, 2, 8, 13, 1, 6, 3, 5, 9),
(554, 2, 8, 14, 1, 6, 3, 3, 9),
(555, 2, 8, 15, 0, 6, 3, 3, 7),
(556, 2, 8, 16, 2, 6, 3, 3, 7),
(557, 2, 8, 17, 2, 5, 3, 3, 7),
(558, 2, 8, 18, 2, 4, 3, 3, 7),
(559, 2, 8, 19, 2, 4, 3, 3, 7),
(560, 2, 8, 20, 2, 4, 3, 3, 7),
(561, 2, 9, 1, 0, 5, 3, 4, 8),
(562, 2, 9, 2, 0, 4, 3, 4, 8),
(563, 2, 9, 3, 2, 3, 3, 3, 8),
(564, 2, 9, 4, 2, 2, 3, 3, 8),
(565, 2, 9, 5, 2, 1, 3, 3, 8),
(566, 2, 9, 6, 0, 1, 2, 4, 8),
(567, 2, 9, 7, 1, 1, 1, 4, 8),
(568, 2, 9, 8, 1, 2, 2, 5, 8),
(569, 2, 9, 9, 1, 3, 4, 5, 8),
(570, 2, 9, 10, 1, 4, 4, 5, 8),
(571, 2, 9, 11, 1, 5, 2, 5, 8),
(572, 2, 9, 12, 1, 5, 3, 4, 9),
(573, 2, 9, 13, 1, 5, 3, 5, 9),
(574, 2, 9, 14, 1, 5, 3, 3, 9),
(575, 2, 9, 15, 0, 5, 3, 3, 9),
(576, 2, 9, 16, 2, 6, 3, 3, 7),
(577, 2, 9, 17, 2, 6, 3, 3, 7),
(578, 2, 9, 18, 2, 5, 3, 3, 7),
(579, 2, 9, 19, 2, 5, 3, 3, 7),
(580, 2, 9, 20, 2, 5, 3, 3, 7),
(581, 2, 10, 1, 2, 5, 3, 3, 8),
(582, 2, 10, 2, 2, 4, 3, 3, 8),
(583, 2, 10, 3, 0, 3, 3, 4, 8),
(584, 2, 10, 4, 2, 2, 3, 3, 8),
(585, 2, 10, 5, 2, 1, 3, 3, 8),
(586, 2, 10, 6, 3, 0, 2, 4, 8),
(587, 2, 10, 7, 1, 1, 1, 4, 8),
(588, 2, 10, 8, 1, 2, 3, 4, 8),
(589, 2, 10, 9, 1, 3, 4, 5, 8),
(590, 2, 10, 10, 1, 4, 5, 5, 8),
(591, 2, 10, 11, 1, 4, 3, 5, 8),
(592, 2, 10, 12, 1, 4, 3, 4, 9),
(593, 2, 10, 13, 0, 4, 2, 5, 9),
(594, 2, 10, 14, 0, 4, 2, 3, 9),
(595, 2, 10, 15, 0, 4, 3, 3, 9),
(596, 2, 10, 16, 2, 5, 3, 3, 9),
(597, 2, 10, 17, 2, 6, 3, 3, 7),
(598, 2, 10, 18, 2, 6, 3, 3, 7),
(599, 2, 10, 19, 2, 6, 3, 3, 7),
(600, 2, 10, 20, 2, 6, 3, 3, 7),
(601, 2, 11, 1, 2, 5, 3, 3, 8),
(602, 2, 11, 2, 2, 4, 3, 3, 8),
(603, 2, 11, 3, 0, 3, 3, 4, 8),
(604, 2, 11, 4, 2, 2, 3, 3, 8),
(605, 2, 11, 5, 2, 1, 3, 3, 8),
(606, 2, 11, 6, 0, 1, 2, 4, 8),
(607, 2, 11, 7, 0, 1, 2, 4, 8),
(608, 2, 11, 8, 1, 2, 1, 4, 8),
(609, 2, 11, 9, 1, 3, 4, 5, 8),
(610, 2, 11, 10, 1, 3, 3, 5, 8),
(611, 2, 11, 11, 1, 3, 3, 5, 9),
(612, 2, 11, 12, 1, 3, 3, 4, 9),
(613, 2, 11, 13, 0, 3, 2, 5, 9),
(614, 2, 11, 14, 0, 3, 1, 3, 9),
(615, 2, 11, 15, 0, 3, 3, 3, 9),
(616, 2, 11, 16, 2, 4, 3, 3, 9),
(617, 2, 11, 17, 2, 5, 3, 3, 9),
(618, 2, 11, 18, 2, 6, 3, 3, 7),
(619, 2, 11, 19, 2, 7, 3, 3, 7),
(620, 2, 11, 20, 2, 8, 3, 3, 7),
(621, 2, 12, 1, 2, 5, 3, 3, 8),
(622, 2, 12, 2, 2, 4, 3, 3, 8),
(623, 2, 12, 3, 2, 3, 3, 3, 8),
(624, 2, 12, 4, 2, 2, 3, 3, 8),
(625, 2, 12, 5, 2, 2, 3, 3, 8),
(626, 2, 12, 6, 2, 2, 3, 3, 8),
(627, 2, 12, 7, 0, 2, 2, 4, 8),
(628, 2, 12, 8, 1, 2, 1, 4, 8),
(629, 2, 12, 9, 1, 3, 3, 4, 8),
(630, 2, 12, 10, 1, 2, 3, 5, 9),
(631, 2, 12, 11, 1, 2, 4, 4, 9),
(632, 2, 12, 12, 1, 2, 3, 4, 9),
(633, 2, 12, 13, 0, 2, 3, 5, 9),
(634, 2, 12, 14, 0, 2, 1, 3, 9),
(635, 2, 12, 15, 0, 3, 2, 3, 9),
(636, 2, 12, 16, 2, 4, 3, 3, 9),
(637, 2, 12, 17, 2, 5, 3, 3, 9),
(638, 2, 12, 18, 2, 6, 3, 3, 9),
(639, 2, 12, 19, 2, 8, 3, 3, 7),
(640, 2, 12, 20, 2, 9, 3, 3, 7),
(641, 2, 13, 1, 2, 5, 3, 3, 8),
(642, 2, 13, 2, 2, 4, 3, 3, 8),
(643, 2, 13, 3, 2, 3, 3, 3, 8),
(644, 2, 13, 4, 2, 3, 3, 3, 8),
(645, 2, 13, 5, 2, 3, 3, 3, 8),
(646, 2, 13, 6, 2, 3, 3, 3, 8),
(647, 2, 13, 7, 0, 3, 2, 4, 8),
(648, 2, 13, 8, 1, 3, 1, 4, 8),
(649, 2, 13, 9, 1, 3, 1, 4, 9),
(650, 2, 13, 10, 1, 2, 3, 4, 9),
(651, 2, 13, 11, 1, 1, 3, 4, 9),
(652, 2, 13, 12, 1, 1, 3, 4, 9),
(653, 2, 13, 13, 1, 1, 3, 5, 9),
(654, 2, 13, 14, 1, 2, 1, 5, 9),
(655, 2, 13, 15, 0, 3, 4, 3, 9),
(656, 2, 13, 16, 2, 4, 3, 3, 9),
(657, 2, 13, 17, 2, 5, 3, 3, 9),
(658, 2, 13, 18, 2, 8, 3, 3, 9),
(659, 2, 13, 19, 2, 9, 3, 3, 9),
(660, 2, 13, 20, 2, 10, 3, 3, 9),
(661, 2, 14, 1, 2, 6, 3, 3, 8),
(662, 2, 14, 2, 2, 5, 3, 3, 8),
(663, 2, 14, 3, 2, 4, 3, 3, 8),
(664, 2, 14, 4, 2, 4, 3, 3, 8),
(665, 2, 14, 5, 2, 4, 3, 3, 8),
(666, 2, 14, 6, 2, 4, 3, 3, 8),
(667, 2, 14, 7, 0, 4, 2, 4, 8),
(668, 2, 14, 8, 0, 4, 2, 4, 9),
(669, 2, 14, 9, 0, 3, 1, 4, 9),
(670, 2, 14, 10, 1, 2, 1, 5, 9),
(671, 2, 14, 11, 1, 1, 2, 5, 9),
(672, 2, 14, 12, 3, 0, 3, 5, 9),
(673, 2, 14, 13, 1, 1, 1, 5, 9),
(674, 2, 14, 14, 1, 2, 5, 5, 9),
(675, 2, 14, 15, 0, 3, 5, 3, 9),
(676, 2, 14, 16, 2, 4, 3, 3, 9),
(677, 2, 14, 17, 2, 5, 3, 3, 9),
(678, 2, 14, 18, 2, 6, 3, 3, 9),
(679, 2, 14, 19, 2, 7, 3, 3, 9),
(680, 2, 14, 20, 2, 8, 3, 3, 9),
(681, 2, 15, 1, 2, 7, 3, 3, 8),
(682, 2, 15, 2, 2, 7, 3, 3, 8),
(683, 2, 15, 3, 2, 6, 3, 3, 8),
(684, 2, 15, 4, 2, 6, 3, 3, 8),
(685, 2, 15, 5, 2, 5, 3, 3, 8),
(686, 2, 15, 6, 2, 5, 3, 3, 8),
(687, 2, 15, 7, 2, 5, 3, 3, 8),
(688, 2, 15, 8, 0, 4, 2, 4, 9),
(689, 2, 15, 9, 0, 3, 2, 4, 9),
(690, 2, 15, 10, 0, 2, 1, 5, 9),
(691, 2, 15, 11, 1, 1, 1, 5, 9),
(692, 2, 15, 12, 1, 1, 1, 5, 9),
(693, 2, 15, 13, 1, 1, 2, 5, 9),
(694, 2, 15, 14, 1, 2, 5, 5, 9),
(695, 2, 15, 15, 1, 3, 3, 3, 9),
(696, 2, 15, 16, 0, 4, 3, 3, 9),
(697, 2, 15, 17, 2, 6, 3, 3, 9),
(698, 2, 15, 18, 2, 7, 3, 3, 9),
(699, 2, 15, 19, 2, 8, 3, 3, 9),
(700, 2, 15, 20, 2, 9, 3, 3, 9),
(701, 2, 16, 1, 2, 8, 3, 3, 8),
(702, 2, 16, 2, 2, 8, 3, 3, 8),
(703, 2, 16, 3, 2, 7, 3, 3, 8),
(704, 2, 16, 4, 2, 7, 3, 3, 8),
(705, 2, 16, 5, 2, 6, 3, 3, 8),
(706, 2, 16, 6, 2, 6, 3, 3, 8),
(707, 2, 16, 7, 2, 5, 3, 3, 8),
(708, 2, 16, 8, 2, 4, 3, 3, 9),
(709, 2, 16, 9, 0, 3, 2, 4, 9),
(710, 2, 16, 10, 0, 2, 2, 4, 9),
(711, 2, 16, 11, 0, 2, 2, 4, 9),
(712, 2, 16, 12, 1, 2, 1, 4, 9),
(713, 2, 16, 13, 0, 2, 1, 5, 9),
(714, 2, 16, 14, 1, 2, 5, 5, 9),
(715, 2, 16, 15, 1, 3, 3, 5, 9),
(716, 2, 16, 16, 1, 4, 4, 3, 9),
(717, 2, 16, 17, 0, 5, 4, 3, 9),
(718, 2, 16, 18, 2, 5, 3, 3, 9),
(719, 2, 16, 19, 2, 6, 3, 3, 9),
(720, 2, 16, 20, 0, 6, 4, 3, 9),
(721, 2, 17, 1, 2, 9, 3, 3, 8),
(722, 2, 17, 2, 2, 9, 3, 3, 8),
(723, 2, 17, 3, 2, 8, 3, 3, 8),
(724, 2, 17, 4, 2, 8, 3, 3, 8),
(725, 2, 17, 5, 2, 7, 3, 3, 8),
(726, 2, 17, 6, 2, 7, 3, 3, 8),
(727, 2, 17, 7, 2, 6, 3, 3, 8),
(728, 2, 17, 8, 2, 5, 3, 3, 9),
(729, 2, 17, 9, 2, 4, 3, 3, 9),
(730, 2, 17, 10, 2, 3, 3, 3, 9),
(731, 2, 17, 11, 0, 3, 2, 4, 9),
(732, 2, 17, 12, 0, 3, 3, 4, 9),
(733, 2, 17, 13, 0, 3, 4, 4, 9),
(734, 2, 17, 14, 0, 3, 5, 4, 9),
(735, 2, 17, 15, 0, 3, 5, 4, 9),
(736, 2, 17, 16, 1, 4, 5, 2, 9),
(737, 2, 17, 17, 1, 5, 5, 2, 9),
(738, 2, 17, 18, 0, 6, 5, 3, 9),
(739, 2, 17, 19, 0, 7, 4, 3, 9),
(740, 2, 17, 20, 0, 7, 4, 3, 9),
(741, 2, 18, 1, 2, 10, 3, 3, 8),
(742, 2, 18, 2, 2, 10, 3, 3, 8),
(743, 2, 18, 3, 2, 9, 3, 3, 8),
(744, 2, 18, 4, 2, 9, 3, 3, 8),
(745, 2, 18, 5, 2, 8, 3, 3, 8),
(746, 2, 18, 6, 2, 8, 3, 3, 8),
(747, 2, 18, 7, 2, 6, 3, 3, 8),
(748, 2, 18, 8, 2, 5, 3, 3, 9),
(749, 2, 18, 9, 2, 5, 3, 3, 9),
(750, 2, 18, 10, 2, 4, 3, 3, 9),
(751, 2, 18, 11, 2, 4, 3, 3, 9),
(752, 2, 18, 12, 2, 4, 3, 3, 9),
(753, 2, 18, 13, 2, 4, 3, 3, 9),
(754, 2, 18, 14, 2, 4, 3, 3, 9),
(755, 2, 18, 15, 0, 4, 5, 3, 9),
(756, 2, 18, 16, 0, 4, 5, 2, 9),
(757, 2, 18, 17, 0, 5, 5, 3, 9),
(758, 2, 18, 18, 0, 6, 2, 3, 9),
(759, 2, 18, 19, 0, 8, 4, 3, 9),
(760, 2, 18, 20, 0, 8, 5, 3, 9),
(761, 2, 19, 1, 2, 11, 3, 3, 8),
(762, 2, 19, 2, 2, 11, 3, 3, 8),
(763, 2, 19, 3, 2, 10, 3, 3, 8),
(764, 2, 19, 4, 2, 10, 3, 3, 8),
(765, 2, 19, 5, 2, 9, 3, 3, 8),
(766, 2, 19, 6, 2, 9, 3, 3, 8),
(767, 2, 19, 7, 2, 8, 3, 3, 8),
(768, 2, 19, 8, 2, 8, 3, 3, 9),
(769, 2, 19, 9, 2, 7, 3, 3, 9),
(770, 2, 19, 10, 2, 7, 3, 3, 9),
(771, 2, 19, 11, 2, 6, 3, 3, 9),
(772, 2, 19, 12, 2, 5, 3, 3, 9),
(773, 2, 19, 13, 2, 5, 3, 3, 9),
(774, 2, 19, 14, 2, 6, 3, 3, 9),
(775, 2, 19, 15, 2, 7, 3, 3, 9),
(776, 2, 19, 16, 2, 8, 3, 3, 9),
(777, 2, 19, 17, 2, 8, 3, 3, 9),
(778, 2, 19, 18, 2, 9, 3, 3, 9),
(779, 2, 19, 19, 0, 9, 3, 4, 9),
(780, 2, 19, 20, 0, 9, 5, 3, 9),
(781, 2, 20, 1, 2, 12, 3, 3, 8),
(782, 2, 20, 2, 2, 11, 3, 3, 8),
(783, 2, 20, 3, 2, 11, 3, 3, 8),
(784, 2, 20, 4, 2, 10, 3, 3, 8),
(785, 2, 20, 5, 2, 10, 3, 3, 8),
(786, 2, 20, 6, 2, 9, 3, 3, 8),
(787, 2, 20, 7, 2, 9, 3, 3, 8),
(788, 2, 20, 8, 2, 8, 3, 3, 9),
(789, 2, 20, 9, 2, 8, 3, 3, 9),
(790, 2, 20, 10, 2, 7, 3, 3, 9),
(791, 2, 20, 11, 2, 7, 3, 3, 9),
(792, 2, 20, 12, 2, 6, 3, 3, 9),
(793, 2, 20, 13, 2, 6, 3, 3, 9),
(794, 2, 20, 14, 2, 6, 3, 3, 9),
(795, 2, 20, 15, 2, 7, 3, 3, 9),
(796, 2, 20, 16, 2, 8, 3, 3, 9),
(797, 2, 20, 17, 2, 9, 3, 3, 9),
(798, 2, 20, 18, 2, 10, 3, 3, 9),
(799, 2, 20, 19, 2, 10, 3, 3, 9),
(800, 2, 20, 20, 0, 10, 2, 3, 9);

-- --------------------------------------------------------

--
-- Table structure for table `Maps`
--

CREATE TABLE IF NOT EXISTS `Maps` (
  `MapID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `MapName` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `ImgURL` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `PreviewURL` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `NumRows` smallint(6) NOT NULL DEFAULT '20',
  `NumCols` smallint(6) NOT NULL DEFAULT '20',
  `AvgDemand` int(10) unsigned NOT NULL DEFAULT '10000',
  `Description` text COLLATE latin1_general_ci NOT NULL,
  PRIMARY KEY (`MapID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=3 ;

--
-- Dumping data for table `Maps`
--

INSERT INTO `Maps` (`MapID`, `MapName`, `ImgURL`, `PreviewURL`, `NumRows`, `NumCols`, `AvgDemand`, `Description`) VALUES
(1, 'Ontario, Canada', 'maps/Ontario.jpg', 'maps/OntarioPreview.jpg', 20, 20, 13500, 'Three major city centres, 13.5 Million people. About 13 GW of power needed on average'),
(2, 'Mexico', 'maps/Mexico.jpg', 'maps/MexicoPreview.jpg', 20, 20, 13500, 'Sunny Mexico! Four major population centers.');

-- --------------------------------------------------------

--
-- Table structure for table `PlayerInGames`
--

CREATE TABLE IF NOT EXISTS `PlayerInGames` (
  `PlayerInGameID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `GameID` int(10) unsigned NOT NULL,
  `PlayerID` int(10) unsigned NOT NULL,
  `TeamName` varchar(55) COLLATE latin1_general_ci NOT NULL,
  `Color` tinyint(4) NOT NULL,
  `Cash` int(10) unsigned NOT NULL DEFAULT '1000',
  `MinCapacity` int(10) unsigned NOT NULL,
  `MaxCapacity` int(10) unsigned NOT NULL,
  `TotalFuelBurned` int(10) unsigned NOT NULL,
  `TotalCO2Emitted` int(10) unsigned NOT NULL,
  `TotalPowerProduced` int(10) unsigned NOT NULL,
  `Score` double NOT NULL,
  `OutOfGame` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`PlayerInGameID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=151 ;

-- --------------------------------------------------------

--
-- Table structure for table `Players`
--

CREATE TABLE IF NOT EXISTS `Players` (
  `PlayerID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `Username` varchar(20) COLLATE latin1_general_ci NOT NULL,
  `Password` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `ScreenName` varchar(55) COLLATE latin1_general_ci NOT NULL,
  PRIMARY KEY (`PlayerID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=26 ;

--
-- Dumping data for table `Players`
--

INSERT INTO `Players` (`PlayerID`, `Username`, `Password`, `ScreenName`) VALUES
(1, 'player1', '10e51f26d3bbd9285c3c79aa56fab434', 'Player 1'),
(2, 'player2', '76f89494fa1a258705697fbf2230dfd7', 'Player 2'),
(3, 'player3', '07e47d949fd792a3b3eb29c3f3674cad', 'Player 3'),
(4, 'player4', 'dd5255616cc25fd6af1fd3d2e021636a', 'Player 4'),
(5, 'player5', 'ce5fd10f5604f58a65fd98321c8231d8', 'Player 5'),
(6, 'player6', 'a31d9c7c3f8407130ca758d1dc042aca', 'Player 6'),
(7, 'player7', 'd95bac4512bb50312b82d8de08f93fbc', 'Player 7'),
(8, 'player8', '03e33ba8f7552f6126970cce19af1581', 'Player 8'),
(9, 'player9', '23764eec6a78554a59a287d40ddb8734', 'Player 9'),
(10, 'player10', 'c7e9f046e14665e8a5868efff2d97fb8', 'Player 10'),
(11, 'player11', 'd3c7ebf01bc9b7bc7b0c87bcc7a871c1', 'Player 11'),
(12, 'player12', 'f7ead5d92d7f99838d141f2198eb45b8', 'Player 12'),
(13, 'player13', '07868432718b806b3237ada42e20f7b1', 'Player 13'),
(14, 'player14', '1dc010a0913954e8f1755676f7d8ac59', 'Player 14'),
(15, 'player15', 'ef0f63ae291645fb25d8de1d227a34af', 'Player 15'),
(16, 'player16', 'adb53f9ef42a4c3a4657918fd512e0a7', 'Player 16'),
(17, 'player17', '81a7fbc262528101c77f1841fd444124', 'Player 17'),
(18, 'player18', '5f04ed3cb78468f8fcbde16f4c6af84e', 'Player 18'),
(19, 'player19', '3df1b4986a81be42570e21685f97622d', 'Player 19'),
(20, 'player20', 'c2ad52251ebce7cefdd4fc1bf69d4c8b', 'Player 20'),
(21, 'player21', '175ee33fa876ec4dcd012c0410bbb59d', 'Player 21'),
(22, 'player22', '687080aa3b4603e73494f5c8039cc5d5', 'Player 22'),
(23, 'player23', 'caa78c762b2945b6c2e57ca5314f2425', 'Player 23'),
(24, 'player24', '1f3377682f8c6040cb16da03d180fc8d', 'Player 24'),
(25, 'player25', 'da469227408bfbeb0b67d213512ff080', 'Player 25');

-- --------------------------------------------------------

--
-- Table structure for table `PowerPlants`
--

CREATE TABLE IF NOT EXISTS `PowerPlants` (
  `PowerPlantID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PlayerInGameID` int(10) unsigned NOT NULL,
  `Type` tinyint(3) unsigned NOT NULL,
  `MaxCapacity` int(10) unsigned NOT NULL,
  `X` smallint(5) unsigned NOT NULL,
  `Y` smallint(5) unsigned NOT NULL,
  `Color` int(10) unsigned NOT NULL,
  `GameID` int(10) unsigned NOT NULL,
  PRIMARY KEY (`PowerPlantID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Type: 1=coal 2=gas 3=nuke 4=wind 5=solar' AUTO_INCREMENT=2195 ;

-- --------------------------------------------------------

--
-- Table structure for table `TurnHistory`
--

CREATE TABLE IF NOT EXISTS `TurnHistory` (
  `TurnHistoryID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `GameID` int(10) unsigned NOT NULL,
  `TotalProduced` int(10) unsigned NOT NULL DEFAULT '0',
  `TotalPurchased` int(10) unsigned NOT NULL DEFAULT '0',
  `Turn` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`TurnHistoryID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=540 ;

-- --------------------------------------------------------

--
-- Table structure for table `WeatherStations`
--

CREATE TABLE IF NOT EXISTS `WeatherStations` (
  `WeatherStationID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `MapID` int(10) unsigned NOT NULL,
  `X` int(10) unsigned NOT NULL,
  `Y` int(10) unsigned NOT NULL,
  `Name` varchar(40) COLLATE latin1_general_ci NOT NULL,
  PRIMARY KEY (`WeatherStationID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=10 ;

--
-- Dumping data for table `WeatherStations`
--

INSERT INTO `WeatherStations` (`WeatherStationID`, `MapID`, `X`, `Y`, `Name`) VALUES
(1, 1, 6, 4, 'Sudbury'),
(3, 1, 9, 17, 'Ottawa'),
(4, 1, 15, 10, 'Toronto'),
(5, 1, 17, 18, 'Syracuse'),
(6, 2, 2, 7, 'El Paso'),
(7, 2, 3, 19, 'Houston'),
(8, 2, 10, 6, 'Los Mochis'),
(9, 2, 14, 12, 'Mexico City');

-- --------------------------------------------------------

--
-- Table structure for table `WeatherStationsInGames`
--

CREATE TABLE IF NOT EXISTS `WeatherStationsInGames` (
  `WeatherStationsInGamesID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `WeatherStationID` int(10) unsigned NOT NULL,
  `GameID` int(10) unsigned NOT NULL,
  `Wind` double unsigned NOT NULL,
  `Sun` double unsigned NOT NULL,
  PRIMARY KEY (`WeatherStationsInGamesID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Win and Sun should be normally between 0 and 1.' AUTO_INCREMENT=153 ;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
