<?php

include_once("generateweather.php");

//echo "check J";

// End of Turn code
// Make validations
$PointsPerSale = 1;
$PointsLostForNotMeetingPledge = 2;  // should always be greater than 1.  if it were 1, then they wouldn't actually lose points for overselling based on the way points are accounted for.


session_start();
if (!isset($_POST['GameID']))
{
  $_SESSION['gmmessage'] = "No game ID found, could not end turn or continue game.  Try logging in again.";
  $_SESSION['gmmessagetype'] = 1;
  header("location: gmlobby.php");
  die;
}
$GameID = $_POST['GameID'];
include_once("validategm.php");

//echo "check L";

include_once("dbconnect.php");

//echo "check K";


// lets get teh game data ID
$gamedata = $con->query("SELECT Games.Date, Games.Time, Games.Turn, Games.Status, Games.GameTitle, Games.MaxTurns, Maps.MapName, Maps.MapID, Maps.ImgURL, Maps.NumRows, Maps.NumCols, Games.GameDataID, Games.Blackouts FROM Games INNER JOIN Maps on Games.MapID=Maps.MapID WHERE Games.GameID=$GameID LIMIT 1;");
if (!$gamedata)
{
  echo "Error 1: Could not find GameID $GameID or matching Map";
  $con->close();
  die;
}
else
{
  $gamerow=mysqli_fetch_row($gamedata);      
  if (!$gamerow)
  {
    echo "Error 2: Could not find GameID or matching Map";
    $con->close();
    die;
  }
  $GameDate = date("l, F j, Y", strtotime($gamerow[0]));      
  $GameTime = $gamerow[1];
  $GameTurn = $gamerow[2];
  $GameStatus = $gamerow[3];
  $GameTitle = $gamerow[4];
  $MaxTurns = $gamerow[5];
  $MapName = $gamerow[6];
  $MapID = $gamerow[7];
  $MapURL = $gamerow[8];
  $MapNumRows = $gamerow[9];
  $MapNumCols = $gamerow[10];
  $GameDataID = $gamerow[11];
  $Blackouts = $gamerow[12];
}
  
  
//echo "check M";  


$msg= "";
$msgtype=0;

$pmsg = "";
// 1. Compute the actual weather for each time
// 
// get the four weather stations and their data
$WeatherData = mysqli_query($con, "SELECT WeatherStationsInGames.Wind, WeatherStationsInGames.Sun, WeatherStations.X, WeatherStations.Y, WeatherStations.Name, WeatherStations.WeatherStationID FROM WeatherStationsInGames INNER JOIN WeatherStations WHERE WeatherStations.WeatherStationID=WeatherStationsInGames.WeatherStationID AND WeatherStationsInGames.GameID=$GameID;");
if (!$WeatherData) // fail if this doesn't work
{
  $_SESSION['gmmessage'] = "No weather data found.  Not sure what happened.  Did not advance turn.";
  $_SESSION['gmmessagetype'] = 1;
  header("location: manage.php?GameID=$GameID");
  die;
}

// make empty weather arrays
$NumWeatherStations = mysqli_num_rows($WeatherData);

// NOT SURE THIS IS CORRECT
$Wind = array_fill(0, $NumWeatherStations, 0);
$Sun = array_fill(0, $NumWeatherStations, 0);
$WX = array_fill(0, $NumWeatherStations, 0);
$WY = array_fill(0, $NumWeatherStations, 0);
$WName = array_fill(0, $NumWeatherStations, 0);
$WID = array_fill(0, $NumWeatherStations, 0);
$WIdMap = array();

//echo "check I";


$i=0;
while ($WeatherRow = mysqli_fetch_row($WeatherData)) // for each weather station
{
  $Wind[$i] = $WeatherRow[0];
  $Sun[$i] = $WeatherRow[1];        
  $WX[$i] = $WeatherRow[2];
  $WY[$i] = $WeatherRow[3];
  $WName[$i] = $WeatherRow[4];
  $WID[$i] = $WeatherRow[5];
     
  
  //array_push($WIdMap, $WID[$i], $i);
  $WIdMap[$WID[$i]] = $i;
  
  
     
  
  //array_push($WIdMap, $WID[$i], $i);
  $WIdMap[$WID[$i]] = $i;
  
  // debug:  - works so far
  // echo $i . "-" . $Wind[$i] . "-" . $Sun[$i] . "-(" . $WX[$i] . "," . $WY[$i] . ") " . $WID[$i] . " [". $WIdMap[$WID[$i]]. "] {" . $WIdMap[3] . "}<BR>";
      
  
  
    $i = $i + 1;
}    

// Now go through and compute the wind and sun foreach X and Y
$MapData = mysqli_query($con, "SELECT Type, Wind, Sun, NearestWeatherStationID FROM MapData WHERE MapID=$MapID ORDER BY X, Y ASC;" );
if (!$MapData)
{
  
  $_SESSION['gmmessage'] = "Fatal error, could not read map!";
  $_SESSION['gmmessagetype'] = 1;
  header("location: manage.php?GameID=$GameID");
  die;
}

// NOTE, CHECK FOR ROW V COL BEHAVIOR
$WindXY = array_fill(0, $MapNumRows, array_fill(0, $MapNumCols, 0));
$SunXY = $WindXY;

//echo "check H";


for ($r=0; $r<$MapNumRows; $r++)
{
  for ($c=0; $c<$MapNumCols; $c++)
  {
    $MapRow = mysqli_fetch_row($MapData);
    if (!$MapRow)
    {      
      $_SESSION['gmmessage'] = "Fatal, no mapinfo, expected at $r X and $c Y";
      $_SESSION['gmmessagetype'] = 1;
      header("location: manage.php?GameID=$GameID");
      die;
    }
        
    $WindThis = $MapRow[1];
    $SunThis = $MapRow[2];
    $NearestWeatherStationIDThis = $MapRow[3];
    $Random1 = mt_rand()/mt_getrandmax();
    $Random2 = mt_rand()/mt_getrandmax();
    
    
    
    
    // debug
    //echo "($r,$c) - Nearest: $NearestWeatherStationIDThis  WIDMap[near]: ".$WIdMap[$NearestWeatherStationIDThis]."  Wind at: " . $Wind[ $WIdMap[$NearestWeatherStationIDThis]  ] . " RHS: " . 0.2*$Random1*(5 - $WindThis) . "<BR>";
    
    $WindXY[$r][$c] = $Wind[ $WIdMap[$NearestWeatherStationIDThis]  ] - 0.1*$Random1*(5 - $WindThis);
    if ($WindXY[$r][$c]<0)
    {
      $WindXY[$r][$c] = 0;
    }
    
    // Sun code this time
    // if the current time is outside of a given range, shut the sun off.  
    if ($GameTime < 8 or $GameTime > 20)
    {
      $SunXY[$r][$c] = 0;
    }
    else
    {
      $SunXY[$r][$c] = $Sun[ $WIdMap[$NearestWeatherStationIDThis]  ] - 0.1*$Random2*(5 - $SunThis);
      if ($SunXY[$r][$c]<0)
      {
        $SunXY[$r][$c] = 0;
      }
    }        
    
    // debug: seems to be working up to here
   // echo "($r,$c) Wind: ". $WindXY[$r][$c] . " Sun: " . $SunXY[$r][$c] . "<BR>";         
  }
}

// 2. Compute the production rate of each power plant except for gas. 

// start by reading the power plant data for this one.
$MaxCapacity = array(0, 0, 0, 0, 0);
$MinCapacity = array(0, 0, 0, 0, 0);
$Operating = array(0, 0, 0, 0, 0);


//echo "check G";

$PowerPlantTypes = mysqli_query($con, "SELECT CoalCapital, CoalOperating, CoalCapacity, GasCapital, GasOperating, GasCapacity, NukeCapital, NukeOperating, NukeCapacity, WindCapital, WindOperating, WindCapacity, SolarCapital, SolarOperating, SolarCapacity FROM GameData WHERE GameDataID = $GameDataID;");
if ($PowerPlantTypes)
{
  $PowerPlantData = mysqli_fetch_row($PowerPlantTypes);
  if ($PowerPlantData)
  {
    $Operating[0] = $PowerPlantData[1];
    $MaxCapacity[0] = $PowerPlantData[2];
    $MinCapacity[0]  = $MaxCapacity[0];
    
    $Operating[1] = $PowerPlantData[4];
    $MaxCapacity[1] = $PowerPlantData[5];
    
    $Operating[2] = $PowerPlantData[7];
    $MaxCapacity[2] = $PowerPlantData[8];
    $MinCapacity[2]  = $MaxCapacity[2];

    $Operating[3] = $PowerPlantData[10];
    $MaxCapacity[3] = $PowerPlantData[11];
    
    $Operating[4] = $PowerPlantData[13];
    $MaxCapacity[4] = $PowerPlantData[14];

    // debug: seems to be working    
    //var_dump($Operating);
    //echo "<BR>";
    //var_dump($MinCapacity);
    //echo "<BR>";
    //var_dump($MaxCapacity);
    //echo "<BR>";
  }
}   

// also, let's get all the player data while we are at it.  We'll read the money now, and mess with each multiple times, and then update it when we are all done.
$players = mysqli_query($con, "SELECT PlayerInGameID, Cash, TotalFuelBurned, TotalCO2Emitted, TotalPowerProduced, Score, PlayerID, TeamName FROM PlayerInGames WHERE GameID=$GameID ORDER BY PlayerInGameID;");
   
if (!$players)
{
  $_SESSION['gmmessage'] = "Error getting player data, turn not advanced.";
  $_SESSION['gmmessagetype'] = 1;
  header("location: manage.php?GameID=$GameID");
  die;
}

//echo "check F";


$NumPlayers = mysqli_num_rows($players);

$PlayerInGameIDs = array_fill(0, $NumPlayers,0);
$PlayerCash = array_fill(0, $NumPlayers,0);
$PlayerMoneyMade = array_fill(0, $NumPlayers,0);
$PlayerTotalPower = array_fill(0, $NumPlayers,0);
$PlayerTotalPowerThisTurn = array_fill(0, $NumPlayers,0);
$PlayerTotalCO2 = array_fill(0, $NumPlayers,0);
$PlayerTotalFuel = array_fill(0, $NumPlayers,0);
$PlayerScore = array_fill(0, $NumPlayers,0);
$PlayerIDs = array_fill(0, $NumPlayers,0);
$PlayerPowerRemaining = array_fill(0, $NumPlayers, 0);
$PlayerSold = array_fill(0, $NumPlayers,0);
$PlayerName = array_fill(0, $NumPlayers,"");
$PlayerStartingScore = array_fill(0, $NumPlayers,0); 

// this array maps playeringameIDs to an index inthe above array.  It saves alot of search operationslater.
// I almost certainly did itwrong.  
$PlayerIDMap = array();

$i=0;
while ($playerrow = mysqli_fetch_row($players))
{
  $PlayerInGameIDs[$i] = $playerrow[0];
  $PlayerCash[$i] = $playerrow[1];
  $PlayerTotalFuel[$i] = $playerrow[2];
  $PlayerTotalCO2[$i] = $playerrow[3];
  $PlayerTotalPower[$i] = $playerrow[4];
  $PlayerScore[$i] = $playerrow[5];
  $PlayerStartingScore[$i] = $playerrow[5];
  $PlayerIDs[$i] = $playerrow[6];
  $PlayerName[$i] = $playerrow[7];
  
  // CHECK
  //skdjdfjfd // garbage so the parser fails
  //array_push($PlayerIDMap, $PlayerInGameIDs[$i], $i);
  $PlayerIDMap[$PlayerInGameIDs[$i]] = $i;
  
  
  //debug: seems to be working
  //echo "[$i]: " . $PlayerInGameIDs[$i]  . "  \$" . $PlayerCash[$i] . " Power: " . $PlayerTotalPower[$i] . " Score: " . $PlayerScore[$i] . "  ID: " . $PlayerIDs[$i] . "  Map: " . $PlayerIDMap[$PlayerInGameIDs[$i]] . "<Br>";
  
  $i = $i + 1;
  
  
}

//echo "check E";
//var_dump($PlayerSold);
//echo "<P>";
//var_dump($NumPlayers);
//echo "<P>";


// now lets go through the list of plants and figure out how much each one actually generates.  (Gas handled later)

$PowerPlantResult = mysqli_query($con, "SELECT Type, X, Y, PlayerInGameID FROM PowerPlants WHERE GameID=$GameID ORDER BY PlayerInGameID, X, Y ASC;");

if (!$PowerPlantResult)
{
  
  $_SESSION['gmmessage'] = "Error acessing power plants in game.";
  $_SESSION['gmmessagetype'] = 1;
  header("location: manage.php?GameID=$GameID");
  die;
}

$NumPowerPlants = mysqli_num_rows($PowerPlantResult);

$PlantType = array_fill(0, $NumPowerPlants, 0);
$PlantX = array_fill(0, $NumPowerPlants, 0);
$PlantY = array_fill(0, $NumPowerPlants, 0);
$PlantPlayerInGameID = array_fill(0, $NumPowerPlants, 0);
$PlantActual = array_fill(0, $NumPowerPlants, 0);
$PlantClosest = array_fill(0, $NumPowerPlants, 0);


//var_dump($Operating);

$i = 0;

$PlayerHasWind = array_fill(0, $NumPlayers, 0);
$PlayerHasSun = array_fill(0, $NumPlayers, 0);
$PlayerTotalWind = array_fill(0, $NumPlayers, 0);
$PlayerTotalSun = array_fill(0, $NumPlayers, 0);

//echo "check D";


while ($PowerPlantRow = mysqli_fetch_row($PowerPlantResult))
{
  
  $PlantType[$i] = $PowerPlantRow[0];
  $PlantX[$i] = $PowerPlantRow[1];
  $PlantY[$i] = $PowerPlantRow[2];
  $PlantPlayerInGameID[$i] = $PowerPlantRow[3];
  
  $p = $PlayerIDMap[$PlantPlayerInGameID[$i]];  
  
  // debuig:
  //echo "$i, Type: " . $PlantType[$i] . "(" . $PlantX[$i] . "," . $PlantY[$i] . ") [". $PlantPlayerInGameID[$i] . "] { $p } ---- ";  
  
  // now, while we are reading the data, let's figure out the actual generation
  if ($PlantType[$i]==1 or $PlantType[$i]==3)
  {
    // set the actual generated here
    $PlantActual[$i] = $MaxCapacity[$PlantType[$i]-1];
    $PlayerPowerRemaining[$p] = $PlayerPowerRemaining[$p] + $PlantActual[$i];    
    
    // charge the player for the operating costs!
    // its ok if they go negative fornow because they may makeit back later.  We'll deal with bankrupcy later (pay for it in points?)
    $PlayerCash[$p] = $PlayerCash[$p] - $Operating[ $PlantType[$i] - 1 ];
    $PlayerMoneyMade[$p] = $PlayerMoneyMade[$p] - $Operating[ $PlantType[$i] - 1 ];
    
    
    $PlayerTotalPowerThisTurn[$p] = $PlayerTotalPowerThisTurn[$p] + $PlantActual[$i];
    
    // debug
    //echo " Cash Remaining \$" . $PlayerCash[$p]; 
    
    
    // FUTURE TO DO
    // add the fuel burned and CO2 emitted scores
  }
  elseif ($PlantType[$i]==4) // Wind
  {
    $PlantActual[$i] = ceil($MaxCapacity[$PlantType[$i]-1] * $WindXY[ $PlantX[$i]-1  ][ $PlantY[$i]-1 ]);
    $PlayerPowerRemaining[$p] = $PlayerPowerRemaining[$p] + $PlantActual[$i];
    $PlayerTotalPowerThisTurn[$p] = $PlayerTotalPowerThisTurn[$p] + $PlantActual[$i];
    
    $PlayerHasWind[$p] = 1;
    $PlayerTotalWind[$p] += $PlantActual[$i]; 
    
    //$msg = $msg . "Wind farm $i located at row " . $PlantX[$i] . " column " . $PlantY[$i] . " produced " . $PlantActual[$i] . " MW this turn.<BR>"; 
    // don't say you produce this yet... you can always turn them off.
  }
  elseif ($PlantType[$i] == 5) // Sun
  {
    $PlantActual[$i] = ceil($MaxCapacity[$PlantType[$i]-1] * $SunXY[ $PlantX[$i]-1  ][ $PlantY[$i]-1 ]);
    $PlayerPowerRemaining[$p] = $PlayerPowerRemaining[$p] + $PlantActual[$i];
    $PlayerTotalPowerThisTurn[$p] = $PlayerTotalPowerThisTurn[$p] + $PlantActual[$i];
    
    $PlayerHasSun[$p] = 1;
    $PlayerTotalSun[$p] += $PlantActual[$i];
    //$msg = $msg . "Solar farm $i located at row " . $PlantX[$i] . " column " . $PlantY[$i] . " produced " . $PlantActual[$i] . " MW this turn.<BR>";
  }
  
  // debug
  // echo " Plant Generated " . $PlantActual[$i] . "  Player remaining:  " . $PlayerPowerRemaining[$p] . " and has produced so far " . $PlayerTotalPower[$p] . " <BR>";
  
  $i = $i + 1;
}


//echo "check C";


// spit out messages about total produced of the intermittents
for ($i=0;$i<$NumPlayers;$i++)
{
  if ($PlayerHasSun[$i] and $PlayerHasWind[$i])
  {
    $msg = $msg . $PlayerName[$i] . " produced " . $PlayerTotalWind[$i] . " MW from wind farms and " . $PlayerTotalSun[$i] . " MW from solar farms for a total of " . $PlayerTotalPowerThisTurn[$i] . " MW from coal, nuke, wind, and solar.<BR>";
  }
  elseif ($PlayerHasSun[$i])
  {
    $msg = $msg . $PlayerName[$i] . " produced " . $PlayerTotalSun[$i] . " MW from solar farms for a total of " . $PlayerTotalPowerThisTurn[$i] . " MW from coal, nuke, and solar.<BR>";
  }
  elseif ($PlayerHasWind[$i])
  {
    $msg = $msg . $PlayerName[$i] . " produced " . $PlayerTotalWind[$i] . " MW from wind farms  for a total of " . $PlayerTotalPowerThisTurn[$i] . " MW from coal, nuke, and wind.<BR>";
  }
  else
  {
    $msg = $msg . $PlayerName[$i] . " produced " . $PlayerTotalPowerThisTurn[$i] . " MW from coal and nuke.<BR>";
  }
  
  
}

//echo "check B";


// 3. Process all of the bids

// First, get the demand we will have to fill.  Note I haven't decided yet if I am going to change the way we do forecasting.
// For now S1 is always the next one.

// get all projections, and find the maximum and minimum while you are getting the data
$DemandForecast = mysqli_query($con, "SELECT S$GameTurn FROM DemandForecast WHERE GameID=$GameID LIMIT 1;");
if (!$DemandForecast) 
{ 
 
  $_SESSION['gmmessage'] = "Fatal error could not open demand.";
  $_SESSION['gmmessagetype'] = 1;
  header("location: manage.php?GameID=$GameID");
  die;
}

$DemandRow = mysqli_fetch_row($DemandForecast);
if (!$DemandRow)
{ 
  $_SESSION['gmmessage'] = "Fatal error 2 could not open demand.";
  $_SESSION['gmmessagetype'] = 1;
  header("location: manage.php?GameID=$GameID");
  die;
}

//echo "check A";


$Demand = $DemandRow[0];
$BaseDemand = $Demand;

// debug
// echo "Demand: $Demand<BR>";
$msg = $msg . "Demand for the turn was $Demand<BR>";

// For efficiency, read all bids from the file into the data set

// Get the turn history ID.  Why oh why did I make this horrible design decision??
$turndata = $con->query("SELECT TurnHistoryID FROM TurnHistory WHERE GameID=$GameID AND Turn=" . $GameTurn . ";");
if (!$turndata)
{
  $_SESSION['gmmessage'] = "Fatal error. Could not get TurnHistoryID";
  $_SESSION['gmmessagetype'] = 1;
  header("location: manage.php?GameID=$GameID");
  die;
}
        
$turnrow = mysqli_fetch_row($turndata);        
$TurnHistoryID = $turnrow[0];      

// debug
//echo "Turnhistory ID $TurnHistoryID <BR>";  


$BidData = mysqli_query($con, "SELECT PlayerInGames.PlayerInGameID, Bids.Rate, Bids.Amount, Bids.BidID FROM Bids INNER JOIN PlayerInGames WHERE PlayerInGames.PlayerInGameID = Bids.PlayerInGameID AND Bids.TurnHistoryID=$TurnHistoryID ORDER BY Bids.Rate ASC;");

$NumBids = mysqli_num_rows($BidData);
$BidPlayerInGameID = array_fill(0, $NumBids, 0);
$BidRate = array_fill(0, $NumBids, 0);
$BidAmount = array_fill(0, $NumBids, 0);
$BidID = array_fill(0, $NumBids, 0);

$i = 0;
while ($BidRow = mysqli_fetch_row($BidData))
{
  $BidPlayerInGameID[$i] = $BidRow[0];
  $BidRate[$i] = $BidRow[1];
  $BidAmount[$i] = $BidRow[2];
  $BidID[$i] = $BidRow[3];
  
  // debug
  // echo $PlayerName[ $PlayerIDMap[$BidPlayerInGameID[$i]]]  . " Bid \$" . $BidRate[$i] . " for " . $BidAmount[$i] . " MW<BR>";
  
  $i = $i + 1;
}

$MarketPrice = 0;
// BID LOGIC

//echo "check 0";


$b = 0;
while ($b < $NumBids)
{

 
  // Actual: Starting with the current bid ($b), see how many bids there at this level.
  $bend = $b;
  $NumSame = 1;
  $TotalAmountBid = $BidAmount[$b];
  while ($BidRate[$bend+1]==$BidRate[$b])   // i.e., if the next bid is the same as this one (remember they are already sorted)
  {
    $bend=$bend+1; // move the end counter.
    $TotalAmountBid = $TotalAmountBid + $BidAmount[$bend]; 
    $NumSame = $NumSame+1;
  }
  
  // debug
  //$msg = $msg . "There are $NumSame bids at the rate of \$" . $BidRate[$b] . "  -- total of $TotalAmountBid MW bid <BR>";
   //echo "There are $NumSame bids at the rate of \$" . $BidRate[$b] . "  -- total of $TotalAmountBid MW bid <BR>";
  
  
 
  // if the total power pledged at this rate is less than the amount we need:
  if ($Demand >= $TotalAmountBid)
  {
  
     
     // debug 
     //$msg = $msg .  "$Demand MW remaining of demand, so buy all available at this price<BR>";
     //echo "$Demand MW remaining of demand, so buy all available at this price<BR>";
     
     // Buy all of it from each person who bid at that price
     while ($b <= $bend)
     {
     
     
       // deduct the amount from the demand
       $Demand = $Demand - $BidAmount[$b];
       
       // deduct the amount sold from the player amount.  May be negative!
       $p = $PlayerIDMap[$BidPlayerInGameID[$b]]; 
       $PlayerPowerRemaining[$p] = $PlayerPowerRemaining[$p] - $BidAmount[$b];
       
       // add money to the player
       $PlayerCash[$p] = $PlayerCash[$p] + $BidAmount[$b] * $BidRate[$b];       
       $PlayerMoneyMade[$p] = $PlayerMoneyMade[$p] + $BidAmount[$b] * $BidRate[$b];
       
       // credit the sale
       $PlayerSold[$p] = $PlayerSold[$p] + $BidAmount[$b];
       
       // increase the score!
       $PlayerScore[$p] = $PlayerScore[$p] + $PointsPerSale * $BidAmount[$b]; // for now, you get points for what you sell to the grid
       
       // this is the best market price so far
       $MarketPrice = max($MarketPrice, $BidRate[$b]);
       
        $msg = $msg . $PlayerName[$p] . " sold " . $BidAmount[$b] . " MW to the market at \$" . $BidRate[$b];
        
        
        //echo $PlayerName[$p] . " sold " . $BidAmount[$b] . " MW to the market at \$" . $BidRate[$b];
        if ($PlayerPowerRemaining[$p] > 0)
        {
          $msg = $msg .  " and has " . $PlayerPowerRemaining[$p] . " MW remaining to sell<BR>"; 
        } 
        elseif ($PlayerPowerRemaining[$p] < 0)
        {
          $msg = $msg .  " and needs to buy or produce " . -$PlayerPowerRemaining[$p] . " MW somehow<BR>"; 
        } 
        else
        {
          $msg = $msg .  " and has met all bid obligations.<BR>";
        }
         
        
       
       $b = $b + 1;
     }
     
   }
   else // too much power!
   {
   
     // debug
    // $msg = $msg .  "There has been more pledged than required.<BR>";
     
     // go until we are out of bidders
     while ($NumSame >= 1)
     {
       // figure out which bidder remaining has the smallest pledge.
       
       // it is possible (and likely) that at some point one bidder inside this loop
       // will have been eliminated in a previous round.
       // so we want to eliminate against that
       
       // in the previous step, if we eliminated the first in group, then $b advances
       // so we are guaranteed that $b is on someone who is still in it.       
       
       $SmallestPledge = $BidAmount[$b];
       
       $bsmall = $b;
       $bi = $b;
       while ($bi <= $bend)
       {
         if ($BidAmount[$bi] > 0 and $BidAmount[$bi] < $SmallestPledge)
         {
           $SmallestPledge = $BidAmount[$bi];
           $bsmall = $bi;          
                       
         }
         $bi++;
       }
       
       // at this point, we know what the smallest pledge is and who had it
       
       // if the smallest pledge is bigger than the remaining demand, then we can just divide it up evenly and stop
       if ($Demand <= $SmallestPledge * $NumSame)
       {
         $AmountPerPlayer = ceil($Demand / $NumSame);
         $Demand = 0;
       }
       else
       {
         $AmountPerPlayer = $SmallestPledge;
       }
         
         
       $bi = $b;
       while ($bi <= $bend)
       {         
         if ($BidAmount[$bi]>0) // ignore those who have fulfilled their bids
         {
           // deduct the amount sold from the player amount.  May be negative!
           $p = $PlayerIDMap[$BidPlayerInGameID[$bi]]; 
           $PlayerPowerRemaining[$p] = $PlayerPowerRemaining[$p] - $AmountPerPlayer;
         
           // add money to the player
           $PlayerCash[$p] = $PlayerCash[$p] + $AmountPerPlayer * $BidRate[$bi];
           $PlayerMoneyMade[$p] = $PlayerMoneyMade[$p] + $AmountPerPlayer * $BidRate[$bi];
         
           // credit the sale
           $PlayerSold[$p] = $PlayerSold[$p] + $AmountPerPlayer;
         
           // increase the score!
           $PlayerScore[$p] = $PlayerScore[$p] + $PointsPerSale * $AmountPerPlayer; // for now, quite arbitrary.
           
           $BidAmount[$bi] = max(0, $BidAmount[$bi] - $AmountPerPlayer);
           
           // this is the highest market price so far
           $MarketPrice = max($MarketPrice, $BidRate[$b]);
           
           // debug
           $msg = $msg .   $PlayerName[$p] . " sold " . $AmountPerPlayer . " MW to the market at \$" . $BidRate[$bi];
           if ($PlayerPowerRemaining[$p] > 0)
           {
             $msg = $msg .   " and has " . $PlayerPowerRemaining[$p] . " MW remaining to sell<BR>"; 
           } 
           elseif ($PlayerPowerRemaining[$p] < 0)
           {
             $msg = $msg .   " and needs to buy or produce " . -$PlayerPowerRemaining[$p] . " MW somehow<BR>"; 
           } 
           else
           {
             $msg = $msg .   " and has met all bid obligations.<BR>";
           }                    
           
           
           // deduct from demand
           if ($Demand > 0)
           {
             $Demand = $Demand - $AmountPerPlayer;
           }
         }
       
         $bi++;
       }
         
       if ($Demand <= 0)
       {
         $Demand = 0;
         break;
       }  
       
       $NumSame--;
       
       if ($bsmall==$b) // if the smallest bidder was the first in our list, it is ok to just move the list forward to avoid this one
       {
         $b++;
       }
     }
     
     $Demand=0; // just be sure it is zero, it should be!
     break; // can break from the loop... we have overproduced, no need to buy more.
   }
   
   $b = $bend + 1; // move on to the next bid
}


//echo "check 2";

 
 // go back again and turn up any gas plants that need to be turned up in order to meet pledges. charge for costs, count CO2, etc.
for ($i=0; $i<$NumPlayers;$i++)
 {
   if ($PlayerPowerRemaining[$i] > 0)
   {
     // debug
     $msg = $msg . $PlayerName[$i] . " has extra power available for sale and does not need to turn on any gas plants.<BR>";
   }
   elseif ($PlayerPowerRemaining[$i] == 0)
   {
     // debug
     $msg = $msg . $PlayerName[$i] . " have no extra power available for sale.<BR>";
   }
   else
   {
     //// echo
     //$msg = $msg . $PlayerName[$i] . " has sold " . -$PlayerPowerRemaining[$i] . " MW more than actually produced, needs to turn on a gas plant or buy it from another player.<BR>";
     
     // turn it on.  go through gas plants and turn them up until they meet the demand.
     for ($j = 0; $j < $NumPowerPlants; $j++)     
     {
       // debug
      // echo "$PlantPlayerInGameID[$j]==$PlayerIDs[$i] and $PlantType[$j]==2 ---- Actual so far $PlantActual[$j] of $MaxCapacity[1]<BR>";
       if ($PlantPlayerInGameID[$j]==$PlayerInGameIDs[$i] and $PlantType[$j]==2) // if the current plant belongs to the current player and it is a gas plant
       {
         // then turn it up!
         if ($PlantActual[$j] < $MaxCapacity[1]) // if this plant has capacity left --- note, I think this is always true! but for some reason I want this here for safety
         {
           // don't turn it up more than we need to.  Also, don't turn it up more than it can go.
           $AmountSold = min($MaxCapacity[1]-$PlantActual[$j], -$PlayerPowerRemaining[$i]);
            
           // account for the power produced
           $PlayerPowerRemaining[$i] = $PlayerPowerRemaining[$i] + $AmountSold;
           $PlantActual[$j] = $PlantActual[$j] + $AmountSold;
           $PlayerTotalPowerThisTurn[$i] = $PlayerTotalPowerThisTurn[$i] + $AmountSold;
            
           // account for the cost of producing it.
           $PlayerCash[$i] = $PlayerCash[$i] - $Operating[1] * ($AmountSold/$MaxCapacity[1]);
           $PlayerMoneyMade[$i] = $PlayerMoneyMade[$i] - $Operating[1] * ($AmountSold/$MaxCapacity[1]);
           
           // Don't add score or sales here... we already sold it and got points for it!
           //$PlayerSold[$i] = $PlayerSold[$i] + $AmountSold;
            
           // note: don't add cash for the sale or points because the player already received those!
           
           // debug
           $msg = $msg .  $PlayerName[$i] . " turned on Gas Plant $j to $AmountSold MW, and now has \$" .  $PlayerCash[$i] . " remaining and still must produce " . -$PlayerPowerRemaining[$i] . " to meet their obligations<BR>";
         }
       }
     } 
     
       
   }
   
 }
 
 //echo "check 3"; 
 

 // Now go through and look at any player with unmet pledges.  Each player with unmet pledges should buy from the other players with more power than actually sold, distributed evenly among them in a similar fashion as above.  All of it at the *market price*, which means that unmet pledges are at best a break even and normally a loss.  In this stage, no gas plants are turned on or up.  
 
// first, determine how much unmet pledges there are and how much extra power there is.  
$NumWithUnmet = 0;
$NumWithExtra = 0;
for ($i=0; $i<$NumPlayers;$i++)
{
 if ($PlayerPowerRemaining[$i] < 0)
 {     
   $NumWithUnmet++;
 } 
 elseif ($PlayerPowerRemaining[$i] > 0)
 {     
   $NumWithExtra++;
 }
}
  
// now, shuffle around. As long as there are both people with need and people with supply, go with that
while ($NumWithUnmet>0 and $NumWithExtra > 0)
{
  // search through the players and determine the amount that everyone will participate in.
  // worst case:    
  $UnmetPledges = 0;
  $ExtraPower = 0; 
  
  for ($i=0; $i<$NumPlayers;$i++)
  {
   if ($PlayerPowerRemaining[$i] < 0)
   {     
     $UnmetPledges = $UnmetPledges - $PlayerPowerRemaining[$i];     
   } 
   elseif ($PlayerPowerRemaining[$i] > 0)
   {
     $ExtraPower = $ExtraPower + $PlayerPowerRemaining[$i];     
   }      
  }
    
  $TotalAmountToTransfer = min($UnmetPledges, $ExtraPower);
  $AmountPerBuyer = $TotalAmountToTransfer / $NumWithUnmet;      
  $AmountPerSeller = $TotalAmountToTransfer / $NumWithExtra;
  $SmallestIs = 0;
  
  // if any of the amounts per buyer or seller are more than any individual buyer or seller, then we need to drop the total sold down.  We also know that 
  for ($i=0; $i<$NumPlayers;$i++)
  {
    if ($PlayerPowerRemaining[$i] < 0 and -$PlayerPowerRemaining[$i] < $AmountPerBuyer)
    {     
      $AmountPerBuyer = -$PlayerPowerRemaining[$i];
      $TotalAmountToTransfer = $AmountPerBuyer * $NumWithUnmet;
      $AmountPerSeller = $TotalAmountToTransfer / $NumWithExtra;          
    } 
    elseif ($PlayerPowerRemaining[$i] > 0 and $PlayerPowerRemaining[$i] < $AmountPerSeller)
    {
      $AmountPerSeller = $PlayerPowerRemaining[$i];
      $TotalAmountToTransfer = $AmountPerSeller * $NumWithExtra;
      $AmountPerBuyer = $TotalAmountToTransfer / $NumWithUnmet;     
    }      
  }
  
  // Ok!  At this point, we should be good.  Go ahead and make the sales transfers.
  for ($i=0; $i<$NumPlayers;$i++)
  {
    if ($PlayerPowerRemaining[$i] < 0)
    {     
      $PlayerCash[$i] = $PlayerCash[$i] - $MarketPrice * $AmountPerBuyer;   
      $PlayerMoneyMade[$i] = $PlayerMoneyMade[$i] - $MarketPrice * $AmountPerBuyer;
      $PlayerPowerRemaining[$i] = $PlayerPowerRemaining[$i] + $AmountPerBuyer;
      
      // the player should lose points because if they have to buy power from another player, they shouldn't have gotten points for power they sold but didn't produce (they were middle man)     
      $PlayerScore[$i] = $PlayerScore[$i] - $PointsPerSale * $AmountPerBuyer; // for now, quite arbitrary.  
      
      // debug
      $msg = $msg .  $PlayerName[$i] . " purchased $AmountPerBuyer MW from the general market at the market rate (\$ $MarketPrice) and now has \$" .  $PlayerCash[$i] . " remaining";
      if ($PlayerPowerRemaining[$i]<0)
      { 
        $msg = $msg .  " and still must produce " . -$PlayerPowerRemaining[$i] . " to meet their obligations<BR>";
      }
      else
      { 
        $msg = $msg .  " and has no more need to buy power externally <BR>";
      }
      
      
                 
    } 
    elseif ($PlayerPowerRemaining[$i] > 0)
    {
      $PlayerCash[$i] = $PlayerCash[$i] + $MarketPrice * $AmountPerSeller;
      $PlayerMoneyMade[$i] = $PlayerMoneyMade[$i] + $MarketPrice * $AmountPerSeller;   
      $PlayerPowerRemaining[$i] = $PlayerPowerRemaining[$i] - $AmountPerSeller;
      $PlayerSold[$i] = $PlayerSold[$i] + $AmountPerSeller;
      
      // they get points because they generated power and sold it to someone
      $PlayerScore[$i] = $PlayerScore[$i] + $PointsPerSale * $AmountPerSeller; // for now, quite arbitrary.
      // debug
      $msg = $msg .  $PlayerName[$i] . " sold $AmountPerSeller MW to the general market at the market rate (\$ $MarketPrice) and now has \$" .  $PlayerCash[$i];
      if ($PlayerPowerRemaining[$i]>0)
      { 
        $msg = $msg .  " and still has " . $PlayerPowerRemaining[$i] . " overproduced for sale<BR>";
      }
      else
      { 
        $msg = $msg .  " and has no extra power to sell <BR>";
      }      
    }      
  }
  
  // go back and recalculate this information. If a whole bunch dropped off the map it just got a lot easier. 
  $NumWithUnmet = 0;
  $NumWithExtra = 0;
  for ($i=0; $i<$NumPlayers;$i++)
  {
   if ($PlayerPowerRemaining[$i] < 0)
   {     
     $NumWithUnmet++;
   } 
   elseif ($PlayerPowerRemaining[$i] > 0)
   {     
     $NumWithExtra++;
   }
  }
  
}    

//echo "check 4";


// OK!  Now, either: 1) all the available solar and wind has been sold, plus any overproduced coal, gas, and nuclear to meet all pledges. or 2) all pledges are met but demand is unsatisfied
// So, now, if there are any unmet pledges, this means that those people have maxed out their gas plants and bought all available wind, solar, coal, and nuke that was produced and left unsold to the grid.
// So. What should happen now is that those people with unmet pledges need to see if the players who have met all of their obligations (and by the way, have also sold all of their coal, nuke, wind and solar so there is nothing extra) need to ask the other power plants if they can turn on their gas plants for them.  The sale price will be market rate (if that is lower than the cost of gas, the market rate moves up to 150% cost of gas).
// If all pledges are met, then this part will automatically skip.   


// The extra power is the sum total of remaining power plant capacity if firing gas
$ExtraPower = 0;  
$NumPlantsWithExtra = 0;
$SmallestPerPlant = $MaxCapacity[1];
for ($j = 0; $j < $NumPowerPlants; $j++)     
{
  if ($PlantType[$j]==2 and $PlantActual[$j] < $MaxCapacity[1]) // if the current plant gas plant has more capacity
  {
    $ExtraPower = $ExtraPower + ($MaxCapacity[1] - $PlantActual[$j]);
    $SmallestPerPlant = min($SmallestPerPlant, ($MaxCapacity[1] - $PlantActual[$j]));
    $NumPlantsWithExtra++;              
  }
}

// debug

//echo "check 5";


// see if there is enough extra power to go around. 

while ($NumWithUnmet > 0 and $NumPlantsWithExtra>0)  // note $NumPlantsWithExtra is referring only to the gas plants since all of the solar, wind, coal, and nuke will be ZERO in the event that $NumWithUnmet>0 at this point.
{
  //echo "There is still $ExtraPower MW of gas capacity we can turn on if we need to. ($SmallestPerPlant)<BR>";
// search through the players and determine the amount that everyone will participate in.
  // worst case:    
  $UnmetPledges = 0;
     
  
  for ($i=0; $i<$NumPlayers;$i++)
  {
   if ($PlayerPowerRemaining[$i] < 0)
   {     
     $UnmetPledges = $UnmetPledges - $PlayerPowerRemaining[$i];     
   }          
  }
  
    
  $TotalAmountToTransfer = min($UnmetPledges, $SmallestPerPlant*$NumPlantsWithExtra);
  $AmountPerBuyer = $TotalAmountToTransfer / $NumWithUnmet;      
  $AmountPerPlant = $TotalAmountToTransfer / $NumPlantsWithExtra;
  $SmallestIs = 0;
  
  // if any of the amounts per buyer or seller are more than any individual buyer or seller, then we need to drop the total sold down.  We also know that 
  for ($i=0; $i<$NumPlayers;$i++)
  {
    if ($PlayerPowerRemaining[$i] < 0 and -$PlayerPowerRemaining[$i] < $AmountPerBuyer)
    {     
      $AmountPerBuyer = -$PlayerPowerRemaining[$i];
      $TotalAmountToTransfer = $AmountPerBuyer * $NumWithUnmet;
      $AmountPerPlant = $TotalAmountToTransfer / $NumPlantsWithExtra;          
    }          
  }
  
  // debug
  //echo "-- Amount per plant: $AmountPerPlant   Amount per buyer: $AmountPerBuyer<BR>";
  
  // Ok!  At this point, we should be good.  Go ahead and make the sales transfers.
  
  // the producers produce it.
  for ($j=0; $j < $NumPowerPlants; $j++)     
  {
    if ($PlantType[$j]==2 and $PlantActual[$j] < $MaxCapacity[1]) // if the current plant gas plant has more capacity
    {
      // all future sales prices at this point are the market rate or a minimum of 50% above the cost of operating a gas plant.
      if ($MarketPrice < 1.5*$Operating[1]/$MaxCapacity[1])
      {
        $MarketPrice = 1.5*$Operating[1]/$MaxCapacity[1];
        $msg = $msg . "Because gas is at a premium, the market price has been raised to \$ $MarketPrice so that gas producers who turn up their gas plants more than they pledged can make a nice profit.<BR>";
      }
          
    
      // this plant should turn up.
      $PlantActual[$j] = $PlantActual[$j] + $AmountPerPlant;
      
      $p = $PlayerIDMap[$PlantPlayerInGameID[$j]];
      
      // account for the power produced            
      $PlayerTotalPowerThisTurn[$p] = $PlayerTotalPowerThisTurn[$p] + $AmountPerPlant;
      
      // increase the score!
      $PlayerScore[$p] = $PlayerScore[$p] + $PointsPerSale * $AmountPerPlant; // for now, quite arbitrary.         
      
      // account for the cost of producing it and selling it.
      $PlayerCash[$p] = $PlayerCash[$p] - $Operating[1] * ($AmountPerPlant/$MaxCapacity[1]) + $MarketPrice * $AmountPerPlant;
      $PlayerMoneyMade[$p] = $PlayerMoneyMade[$p] - $Operating[1] * ($AmountPerPlant/$MaxCapacity[1]) + $MarketPrice * $AmountPerPlant;
      
      $PlayerSold[$p] = $PlayerSold[$p] + $AmountPerPlant;
      
      // FUTURE account for emissions and so forth here.
      
      
            
      //debug
      $msg = $msg . $PlayerName[$p] . " turned up gas plant $j by $AmountPerPlant MW to a new output of $PlantActual[$j] and sold it on the general market at \$ $MarketPrice and now has \$ $PlayerCash[$p] <BR>";
      
                     
    }
  }
  
  // the buyers buy it
  for ($i=0; $i<$NumPlayers;$i++)
  {
    if ($PlayerPowerRemaining[$i] < 0)
    {     
      $PlayerCash[$i] = $PlayerCash[$i] - $MarketPrice * $AmountPerBuyer;   
      $PlayerMoneyMade[$i] = $PlayerMoneyMade[$i] - $MarketPrice * $AmountPerBuyer;
      $PlayerPowerRemaining[$i] = $PlayerPowerRemaining[$i] + $AmountPerBuyer;
      
      // decrease the score! Anyone who needs to buy power at this point received a higher score than they deserved earlier, so deduct it back here
      $PlayerScore[$i] = $PlayerScore[$i] - $PointsPerSale * $AmountPerPlant; // for now, quite arbitrary. 
      
      // debug
      $msg = $msg .  $PlayerName[$i] . " purchased $AmountPerBuyer MW from the general market at the market rate (\$ $MarketPrice) and now has \$" .  $PlayerCash[$i] . " remaining";
      if ($PlayerPowerRemaining[$i]<0)
      { 
        $msg = $msg .   " and still must produce " . -$PlayerPowerRemaining[$i] . " to meet their obligations<BR>";
      }
      else
      { 
        $msg = $msg .   " and has no more need to buy power externally <BR>";
      }
                 
    }           
  }
  
  // recalculate the capacity.  Maybe we've run out of gas, so stop.
  $ExtraPower = 0;  
  $NumPlantsWithExtra = 0;
  $SmallestPerPlant = $MaxCapacity[1];
  for ($j = 0; $j < $NumPowerPlants; $j++)     
  {
    if ($PlantType[$j]==2 and $PlantActual[$j] < $MaxCapacity[1]) // if the current plant gas plant has more capacity
    {
      $ExtraPower = $ExtraPower + ($MaxCapacity[1] - $PlantActual[$j]);
      $SmallestPerPlant = min($SmallestPerPlant, ($MaxCapacity[1] - $PlantActual[$j]));
      $NumPlantsWithExtra++;              
    }
  }
  
  $NumWithUnmet = 0;  
  for ($i=0; $i<$NumPlayers;$i++)
  {
   if ($PlayerPowerRemaining[$i] < 0)
   {     
     $NumWithUnmet++;
   } 
  }  
   
}  

//echo "check 6";

// OK... at this point, if there are still unmet pledges then we are guaranteed to have run out of power.

$Blackout = 0;
// We may be in blackout, so check it out.

if ($NumWithUnmet > 0)
{
  // In this case, we cannot fire any more gas plants. Having unmet pledges at this point means that all possible power has been produced and sold.  This is certainly blackout conditions
  if ($Demand <= 0)
  {
    $msg = $msg .  "<B>BLACKOUT!</B> Although the power companies together pledged enough, they could not collectively produce enough power to meet demand!<BR>";
    //echo "<B>BLACKOUT!</B> Although the power companies together pledged enough, they could not collectively produce enough power to meet demand!<BR>";
    //die;
    $Blackout = 1;
        
  }
  else
  {
    $msg = $msg .   "<B>BLACKOUT!</B> Not only did the power companies collectively not pledge enough, you as a group did not even produce as much as you pledged you would.<BR>";
    //echo "<B>BLACKOUT!</B> Not only did the power companies collectively not pledge enough, you as a group did not even produce as much as you pledged you would.<BR>";
    //die;
    $Blackout = 1;
    
  }
}  
else
{
  
  if ($Demand > 0) // all of the pledges have been met but there is still more demand.  
  {    
    
    // at this point in the logic, it is possible that there is extra wind, solar, coal, and nuke available.  This would occur if there never was a time when we needed to fire
    // up other people's gas plants to satisfy unmet demands (or for example, everyone meets their own demand nicely and has extra, but the pledges don't add up)
    
    // so, let's first see if there is extra coal, nuke, wind, and solar to sell.  
    //echo "-------<BR>";
    //    // power plant dump
    //   for ($j=0; $j < $NumPowerPlants; $j++)     
    //    {
    //      $cap = $MaxCapacity[$PlantType[$j]-1] - $PlantActual[$j];
    //      if ($cap>0)
    //      {
    //        echo "<B>Plant $j, Type: " . $PlantType[$j] . " PlantActual: " . $PlantActual[$j] . "  Capacity: $cap</b><BR>";
    //      }
    //      else
    //      {
    //        echo "Plant $j, Type: " . $PlantType[$j] . " PlantActual: " . $PlantActual[$j] . "  Capacity: $cap<BR>";
    //      }
    //    }
        
    while (1)
    {
              
      $ExtraPower=0;
      $NumPlayersWithExtra=0;
      $SmallestPerPerson=10000000000;
            
      // set the market price.  Basically it's the same but if it is so small as to be cheaper than nuke, make it the price of nuke so we at least make a little money or break even.
      // this would happen only if a gas plant hasn't turn on yet. ONce a gas plant turns on, the market price would be higher.
      // $MarketPrice = max($MarketPrice, $Operating[0]/$MaxCapacity[0]);
      
      
      // all future sales prices at this point are the market rate or a minimum of 50% above the cost of operating a gas plant.
      if ($MarketPrice < $Operating[0]/$MaxCapacity[0])
      {
        $MarketPrice = $Operating[0]/$MaxCapacity[0];
        $msg = $msg . "Because the market price is so low, the market price has been raised to \$ $MarketPrice so that extra power can be sold without causing a loss to the producer.<BR>";
      }
      
      for ($i=0;$i<$NumPlayers;$i++)
      {
        if ($PlayerPowerRemaining[$i] > 0)
        {
          $ExtraPower += $PlayerPowerRemaining[$i];      // note, and power remaining would not include gas plants since they wouldn't have been turned up higher than needed
          $NumPlayersWithExtra++;
          $SmallestPerPerson = min($SmallestPerPerson, $PlayerPowerRemaining[$i]);          
        }
        //echo $PlayerName[$i] . " has " . $PlayerPowerRemaining[$i] . " unsold power from coal, nuke, wind, and solar.<BR>";
              
      }
      if ($NumPlayersWithExtra <=0 or $ExtraPower <=0)
      {       
        break;
      }
      $SmallestPerPerson = min($Demand/$NumPlayersWithExtra, $SmallestPerPerson);
      
      // ok, go back and sell that power.
      for ($i=0;$i<$NumPlayers;$i++)
      {
        if ($PlayerPowerRemaining[$i] > 0)
        {
          // account for the power remaining            
          $PlayerPowerRemaining[$i] = $PlayerPowerRemaining[$i] - $SmallestPerPerson;
          
          // account for demand satisfaction
          $Demand -= $SmallestPerPerson;
          
          // increase the score!
          $PlayerScore[$i] = $PlayerScore[$i] + $PointsPerSale * $SmallestPerPerson; // for now, quite arbitrary.         
          
          // account for the cost of producing it and selling it.
          $PlayerCash[$i] = $PlayerCash[$i] + $MarketPrice * $SmallestPerPerson;
          $PlayerMoneyMade[$i] = $PlayerMoneyMade[$i] + $MarketPrice * $SmallestPerPerson;
          
          $PlayerSold[$i] = $PlayerSold[$i] + $SmallestPerPerson;  
          
          // debug
          $msg = $msg . $PlayerName[$i] . " sold an extra $SmallestPerPerson MW to the grid to help meet demand above their pledge at a rate of \$ $MarketPrice and now has \$" . $PlayerCash[$i] . " and " . $PlayerPowerRemaining[$i] . " MW remaining for sale<BR>";
          //echo $PlayerName[$i] . $PlayerName[$i] . " sold an extra $SmallestPerPerson MW to the grid to help meet demand above their pledge at a rate of \$ $MarketPrice and now has \$" . $PlayerCash[$i] . " and " . $PlayerPowerRemaining[$i] . " MW remaining for sale<BR>";
        }
      }
      
      $Demand = floor($Demand);
      if ($Demand <= 0)
      {
        break;
      }
    }   
         
    
    // assert: at this point, there is either no more extra power, or, demand has been satisfied.
    // if the demand is zero, we are done.
    if ($Demand <= 0)
    {    
      $msg = $msg .   "<B>SUCCESS!</B> The power companies collectively produced enough to meet the demand, even though your pledges were not enough.<BR>";
      //echo "<B>SUCCESS!</B> The power companies collectively produced enough to meet the demand, even though your pledges weren't enough.<BR>";
      //die;
             
    }
    else
    {
    
      
      // find the capacity of the gas plants
      // recalculate the capacity.  Maybe we've run out of gas, so stop.
      $ExtraPower = 0;  
      $NumPlantsWithExtra = 0;
      $SmallestPerPlant = $MaxCapacity[1];
      for ($j = 0; $j < $NumPowerPlants; $j++)     
      {
        if ($PlantType[$j]==2 and $PlantActual[$j] < $MaxCapacity[1]) // if the current plant gas plant has more capacity
        {
          $ExtraPower = $ExtraPower + ($MaxCapacity[1] - $PlantActual[$j]);
          $SmallestPerPlant = min($SmallestPerPlant, ($MaxCapacity[1] - $PlantActual[$j]));
          $NumPlantsWithExtra++;              
        }
      }
      
     
    
      if ($ExtraPower > 0)
      {
      
        // in some rare cases, the market price may be too small to make gas plants worth it.  There should be some profit in it!
        // $MarketPrice = max($MarketPrice, 1.5*$Operating[1]/$MaxCapacity[1]);
        // all future sales prices at this point are the market rate or a minimum of 50% above the cost of operating a gas plant.
        if ($MarketPrice < 1.5*$Operating[1]/$MaxCapacity[1])
        {
          $MarketPrice = 1.5*$Operating[1]/$MaxCapacity[1];
          $msg = $msg . "Because gas is at a premium, the market price has been raised to \$ $MarketPrice so that gas producers who turn up their gas plants more than they pledged can make a nice profit.<BR>";
        }
        
        // keep selling power to the grid in the same way as before... remember the market rates are higher now... yippie skippie!
        while ($ExtraPower > 0 and $Demand>0)
        {
          $TotalAmountToTransfer = min($Demand, $SmallestPerPlant*$NumPlantsWithExtra);              
          $AmountPerPlant = $TotalAmountToTransfer / $NumPlantsWithExtra;
          
          //echo "---------------------------<BR>";
          
          //echo "TotalAmountToTransfer: $TotalAmountToTransfer  Demand: $Demand   SmallestPerPlant: $SmallestPerPlant  NumPlantsWithExtra: $NumPlantsWithExtra  AmountPerPlant:$AmountPerPlant<BR>";
          
          
          // power plant dump
          //for ($j=0; $j < $NumPowerPlants; $j++)     
          //{
          //  $cap = $MaxCapacity[$PlantType[$j]-1] - $PlantActual[$j];
          //  if ($cap>0)
          //  {
          //    echo "<B>Plant $j, Type: " . $PlantType[$j] . " PlantActual: " . $PlantActual[$j] . "  Capacity: $cap</b><BR>";
          //  }
          //  else
          //  {
          //    echo "Plant $j, Type: " . $PlantType[$j] . " PlantActual: " . $PlantActual[$j] . "  Capacity: $cap<BR>";
          // }
          //}
          
          //die;
                          
          
          // debug
          //echo "Selling extra capcity to the grid ($Demand MW demand remaining) -- Amount per plant: $AmountPerPlant, new demand is ";
                          
          $Demand -= $TotalAmountToTransfer;
          
          //echo $Demand. " MW <BR>";
          
          // Ok!  At this point, we should be good.  Go ahead and make the sales transfers.
          
          // the producers produce it.
          for ($j=0; $j < $NumPowerPlants; $j++)     
          {
            if ($PlantType[$j]==2 and $PlantActual[$j] < $MaxCapacity[1]) // if the current plant gas plant has more capacity
            {
              // this plant should turn up.
              $PlantActual[$j] = $PlantActual[$j] + ceil($AmountPerPlant);
              
              $p = $PlayerIDMap[$PlantPlayerInGameID[$j]];
              
              // account for the power produced            
              $PlayerTotalPowerThisTurn[$p] = $PlayerTotalPowerThisTurn[$p] + $AmountPerPlant;
              
              // increase the score!
              $PlayerScore[$p] = $PlayerScore[$p] + $PointsPerSale * $AmountPerPlant; // for now, quite arbitrary.         
              
              // account for the cost of producing it and selling it.
              $PlayerCash[$p] = $PlayerCash[$p] - $Operating[1] * ($AmountPerPlant/$MaxCapacity[1]) + $MarketPrice * $AmountPerPlant;
              $PlayerMoneyMade[$p] = $PlayerMoneyMade[$p] - $Operating[1] * ($AmountPerPlant/$MaxCapacity[1]) + $MarketPrice * $AmountPerPlant;
              
              $PlayerSold[$p] = $PlayerSold[$p] + $AmountPerPlant;
              
              
              
              // FUTURE account for emissions and so forth here.
              
              
                    
              //debug
              $msg = $msg .   $PlayerName[$p] . " turned up gas plant $j by $AmountPerPlant MW to a new output of $PlantActual[$j] and sold it to the grid at \$ $MarketPrice and now has \$ $PlayerCash[$p] <BR>";
              
                             
            }
          }
          
          // recalculate the capacity.  Maybe we've run out of gas, so stop.
          $ExtraPower = 0;  
          $NumPlantsWithExtra = 0;
          $SmallestPerPlant = $MaxCapacity[1];
          for ($j = 0; $j < $NumPowerPlants; $j++)     
          {
            if ($PlantType[$j]==2 and $PlantActual[$j] < $MaxCapacity[1]) // if the current plant gas plant has more capacity
            {
              $ExtraPower = $ExtraPower + ($MaxCapacity[1] - $PlantActual[$j]);
              $SmallestPerPlant = min($SmallestPerPlant, ($MaxCapacity[1] - $PlantActual[$j]));
              $NumPlantsWithExtra++;              
            }
          }
          
          
        }
        
       
        
        
        if ($Demand > 0)
        {
          $msg = $msg .   "<B>BLACKOUT!</B> Although all of the companies met their pledges, the pledges were collectively too low and did not have enough backup to power the grid.<BR>";
          $Blackout = 1;
        }
        else
        {
          $msg = $msg .   "<B>SUCCESS!</B> The power companies collectively produced enough to meet the demand, even though your pledges were not enough and you needed to fire up extra gas plants.<BR>";  
        }
        
      }
      else
      {
        $msg = $msg .   "<B>BLACKOUT!</B> Although all of the companies met their pledges, the pledges were collectively too low and did not have enough backup to power the grid.<BR>";
        $Blackout = 1;
      }    
    }
  }
  else // oh!  Nothing is unmet and demand is satisfied... cool.
  {
    $msg = $msg . "<B>SUCCESS!</B> The power companies collectively produced enough to meet the demand.<BR>";    
        
  }  
}
   
//echo "check 7"; // error is between check 6 and 7. At least narrowed it down. 
//die; 

if ($Blackout)
// lose more points if you didn't meet your pledges.
{
  $Blackouts++;
  
  if ($Blackouts == 1)
  {
    $msg = $msg . "This is your first blackout!  Two more and the game ends!<BR>";
  }  
  elseif ($Blackouts == 2)
  {
    $msg = $msg . "This is your second blackout!  One more and the game ends and everyone loses!<BR>";
  }
  
  if ($Blackouts > 2)
  {
    $msg = $msg . "This is your third blackout!  <B>Game Over! Everyone loses!</B><BR>";
    for ($i=0; $i<$NumPlayers;$i++)
    {    
      $PlayerScore[$i] = 0;      
    }
     
  }
  else
  {
    for ($i=0; $i<$NumPlayers;$i++)
    {
        
      $pts = 0;
      if ($PlayerPowerRemaining[$i]<0)
      {
        $pts = min($PlayerScore[$i], -$PlayerPowerRemaining[$i] * $PointsLostForNotMeetingPledge);   
      }  
      $pts = max(0,min($PlayerScore[$i], $pts + floor(0.5*($PlayerScore[$i]-$pts))));
      
    
      
      
      if ($PlayerPowerRemaining[$i] < 0)
      {
        $msg = $msg . $PlayerName[$i] ." loses more than half points their from the blackout (includes extra penalty for not meeting their pledge).<BR>";
      }
      else
      {
        $msg = $msg . $PlayerName[$i] ." loses half their points from the blackout.<BR>";    
      }
      
      $PlayerScore[$i] = max(0,floor($PlayerScore[$i] - $pts));
    }
  }
  
} 
 
//echo "check 8";
//die;
  
// make all necessary updates to the database for individual players
for ($i=0; $i<$NumPlayers;$i++)
{

  // if the player cash is negative, take a penalty.
  if ($PlayerCash[$i] < 0)
  {
    if ($GameTurn <= 12)
    {
      $msg = $msg . $PlayerName[$i] . " is bankrupt!  Cash has been reset to zero and score is cut in half.  Careful, if you go bankrupt after turn 12, you are out of the game!<BR>";
      //echo $PlayerName[$i] . " is bankrupt!  Cash has been reset to zero and score is cut in half.<BR>";
      $PlayerCash[$i] = 0;
      $PlayerScore[$i] = floor($PlayerScore[$i] / 2);
    }
    else
    {
      $msg = $msg . $PlayerName[$i] . " is bankrupt!  It is after turn 12, so " . $PlayerName[$i] . " is out of the game! Their power plants have been shut down!<BR>";
      //echo $PlayerName[$i] . " is bankrupt!  Cash has been reset to zero and score is cut in half.<BR>";
      $PlayerCash[$i] = 0;
      $PlayerScore[$i] = 0; 
            
      $updateresult = mysqli_query($con, "UPDATE PlayerInGames SET OutOfGame=1, MinCapacity=0, MaxCapacity=0 WHERE PlayerInGameID=" . $PlayerInGameIDs[$i] . ";"); 
      if (!$updateresult)
      {
        echo "ERROR!  String was: UPDATE PlayerInGames SET OutOfGame=1 WHERE PlayerInGameID=" . $PlayerInGameIDs[$i] . ";";
        $con->close();
        die;
      }
      
      // delete their power plants.  For the moment, they can just sit there and do nothing.  No cash, nothing to bid.     
      $updateresult = mysqli_query($con, "DELETE FROM PowerPlants WHERE PlayerInGameID=" . $PlayerInGameIDs[$i] . ";"); 
      if (!$updateresult)
      {
        echo "ERROR!  String was: DELETE FROM PowerPlants WHERE PlayerInGameID=" . $PlayerInGameIDs[$i] . ";";
        $con->close();
        die;
      }
    }
  }

  $updateresult = mysqli_query($con, "UPDATE PlayerInGames SET Cash=" . floor($PlayerCash[$i]) . ", TotalPowerProduced=" . floor($PlayerTotalPower[$i] + $PlayerTotalPowerThisTurn[$i]) . ", Score=" . floor($PlayerScore[$i]) . " WHERE PlayerInGameID=" . $PlayerInGameIDs[$i] . ";"); 
  if (!$updateresult)
  {
    echo "ERROR!  String was: UPDATE PlayerInGames SET Cash=" . floor($PlayerCash[$i]) . ", TotalPowerProduced=" . floor($PlayerTotalPower[$i] + $PlayerTotalPowerThisTurn[$i]) . ", Score=" . floor($PlayerScore[$i]) . " WHERE PlayerInGameID=" . $PlayerInGameIDs[$i] . ";";
    $con->close();
    die;
  }    

}


// determine the change in points overall to print messages
for ($i=0; $i<$NumPlayers;$i++)
{
   $change = round($PlayerScore[$i] - $PlayerStartingScore[$i],0);
   
   if ($change<0)
   {
     $change = -$change;
     $msg = $msg .  $PlayerName[$i] . " lost $change points this turn.<BR>";
   }
   elseif ($change==0)
   { 
     $msg = $msg . $PlayerName[$i] . " had no change in score this turn<BR>";  
   }
   else
   {
     $msg = $msg . $PlayerName[$i] . " gained $change points this turn.<BR>";
   }
}

//echo "check 9";
//die;

// make all the necessary updates to the database for the individual bids
$TotalProducedThisTurn = 0;

$sold = 0;

for ($i=0; $i<$NumBids;$i++)
{
  $p = $PlayerIDMap[$BidPlayerInGameID[$i]];  
  $act = round($PlayerTotalPowerThisTurn[$p],0);
  $sold = round($PlayerSold[$p],0);    
  $unsold = 0;
  if ($PlayerPowerRemaining[$p] > 0)
  {
    $unsold = round($PlayerPowerRemaining[$p],0); 
  } 
  
  $unmet = 0;
  if ($PlayerPowerRemaining[$p] < 0)
  {
    $unmet = round(-$PlayerPowerRemaining[$p],0);
  }
  
  $moneymade = round($PlayerMoneyMade[$p],0);
  
  $TotalProducedThisTurn += $act;  
   
  $updateresult = mysqli_query($con, "UPDATE Bids SET Actual=$act, Sold=$sold, Unsold=$unsold, Unmet=$unmet, MoneyMade=$moneymade WHERE BidID=" . $BidID[$i] . ";"); 
  if (!$updateresult)
  {
    echo "ERROR!  String was: UPDATE Bids SET Actual=$act, Sold=$sold, Unsold=$unsold, Unmet=$unmet, MoneyMade=$moneymade WHERE BidID=" . $BidID[$i] . ";<P>";
   /* echo "Mesage was: <BR>$msg<P>";
    var_dump($i);
    echo "<P>";
    var_dump($NumBids);
    echo "<P>";
    var_dump($sold);
    echo "<P>";
    var_dump($PlayerSold);
    echo "<P>";
    var_dump($PlayerTotalPowerThisTurn);
    echo "<P>";
    var_dump($PlayerPowerRemaining);      */
    
    $con->close();
    die;
  }   

}

//echo "check 10";
//die;

if (!$Blackout)
{
  $TotalSoldThisTurn = $BaseDemand;
}
else
{
  $TotalSoldThisTurn = $TotalProducedThisTurn;
}



// then update into the TUrnHistoryID database
$updateresult = mysqli_query($con, "UPDATE TurnHistory SET TotalProduced=$TotalProducedThisTurn, TotalPurchased=$TotalSoldThisTurn WHERE TurnHistoryID=$TurnHistoryID;"); 
if (!$updateresult)
{
  echo "ERROR!  String was: UPDATE TurnHistory SET TotalProduced=$TotalProducedThisTurn, TotalPurchased=$TotalSoldThisTurn WHERE TurnHistoryID=$TurnHistoryID;";
  $con->close();
  die;
}

// IF LAST TURN
//   Set game to be finished.
//   Put out message accordingly.
// Stop

if ($Blackouts>2)
{
  $updateresult = mysqli_query($con, "UPDATE Games SET Status=2, Message='$msg' WHERE GameID=$GameID;"); 
  
  $con->close();
  $_SESSION['gmmessage'] = $msg;
  $_SESSION['gmmessagetype'] = $msgtype;
  header("location: manage.php?GameID=$GameID");
  die; 
}
elseif ($GameTurn >= $MaxTurns)
{
  // find the winner.
  
  $maxpts = $PlayerScore[0];
  $maxi = 0;
  for ($i=1;$i<$NumPlayers;$i++)
  {
    if ($PlayerScore[$i] > $maxpts)
    {
      $maxpts = $PlayerScore[$i];
      $maxi = $i;
    }
  }  
  
  $GameTurn = $GameTurn + 1;
  
  $msg = $msg . "<B>GAME OVER!</B> " . $PlayerName[$maxi] . " has won with $maxpts Points!!!";
  
  $updateresult = mysqli_query($con, "UPDATE Games SET Status=2, Turn=$GameTurn, Message='$msg' WHERE GameID=$GameID;"); 
  
  $con->close();
  $_SESSION['gmmessage'] = $msg;
  $_SESSION['gmmessagetype'] = $msgtype;
  header("location: manage.php?GameID=$GameID");
  die; 
}  


// 4. Generate new weather forecast.
GenerateWeather($GameID, $con);


// 5. Generate new power demand forecast.
// NO LONGER DOING THIS ...

//echo "check 11";
//die;

// 6. ADvance turn counter
$GameTime = $GameTime + 1;
if ($GameTime == 24) 
{
  $GameTime=0;
  // TO DO, ADD GAME DATE CHANGE AND MESS WITH FORMATTING OF DATES ETC
}
$GameTurn = $GameTurn + 1;

$updateresult = mysqli_query($con, "UPDATE Games SET Turn=$GameTurn, Time=$GameTime, Message='$msg', Blackouts=$Blackouts WHERE GameID=$GameID;"); 
if (!$updateresult)
{
  echo "ERROR!  String was: UPDATE Games SET Turn=$GameTurn, Time=$GameTime, Message='$msg', Blackouts=$Blackouts WHERE GameID=$GameID;<P><P>";  
  $con->close();
  die;
}


// Add a new turn history ID.
$updateresult = mysqli_query($con, "INSERT INTO TurnHistory (GameID, Turn) VALUES ($GameID, $GameTurn);"); 
if (!$updateresult)
{
  echo "ERROR!  String was: INSERT INTO TurnHistory (GameID, Turn) VALUES ($GameID, $GameTurn);";
  $con->close();
  die;
}




// 7. Redirect to the manager.

$con->close();
$_SESSION['gmmessage'] = $msg;
$_SESSION['gmmessagetype'] = $msgtype;
header("location: manage.php?GameID=$GameID");
die;

?>