<?php

session_start(); 
  
if (!isset($_POST['GameID']))
{
  $_SESSION['pmessage'] = "No game ID found, exiting.";
  $_SESSION['pmessagetype'] = 1; 
  header("location: playerjoin.php");  
}

$GameID = $_POST['GameID']; 

if (!isset($_POST['TotalCost']))
{
  $_SESSION['pmessage'] = "No TotalCost found, could not buy item.";
  $_SESSION['pmessagetype'] = 1; 
  header("location: play.php?GameID=$GameID");
  die;    
}
if (!isset($_POST['X']))
{
  $_SESSION['pmessage'] = "No X found, could not buy item.";
  $_SESSION['pmessagetype'] = 1; 
  header("location: play.php?GameID=$GameID");
  die;
}
if (!isset($_POST['Y']))
{
  $_SESSION['pmessage'] = "No Y found, could not buy item.";
  $_SESSION['pmessagetype'] = 1; 
  header("location: play.php?GameID=$GameID");
  die;
}
if (!isset($_POST['Type']))
{
  $_SESSION['pmessage'] = "No Type found, could not buy item.";
  $_SESSION['pmessagetype'] = 1; 
  header("location: play.php?GameID=$GameID");
  die;
}

if (!isset($_POST['PlayerInGameID']))
{
  $_SESSION['pmessage'] = "No PlayerInGameID found, could not buy item.";
  $_SESSION['pmessagetype'] = 1; 
  header("location: play.php?GameID=$GameID");
  die;
}

if (!isset($_POST['Turn']))
{
  $_SESSION['pmessage'] = "No Turn found, could not buy item.";
  $_SESSION['pmessagetype'] = 1; 
  header("location: play.php?GameID=$GameID");
  die;
}

$TotalCost = $_POST['TotalCost'];
$X = $_POST['X'];
$Y = $_POST['Y'];
$Type = $_POST['Type'];
$PlayerInGameID = $_POST['PlayerInGameID'];
$Turn = $_POST['Turn'];  

include_once("dbconnect.php");
include_once("validateplayer.php");


// first get the turnhistory ID (why or why did I do this)
$TurnData = mysqli_query($con, "SELECT TurnHistoryID FROM TurnHistory WHERE GameID=$GameID AND Turn=$Turn;");
if (!$TurnData)
{
   $_SESSION['pmessage'] = "Error checking for the turnhistoryID. String was SELECT TurnHistoryID FROM TurnHistory WHERE GameID=$GameID AND Turn=$Turn;";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;  
}

if ($TurnRow = mysqli_fetch_row($TurnData))
{
  $TurnHistoryID = $TurnRow[0];
}
else
{
   $_SESSION['pmessage'] = "Error checking for the turnhistoryID, no turn in the database!!!";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;  
}


// safety: validate that the player has enough money
$PlayerResult = mysqli_query($con, "SELECT Cash, Color, MinCapacity, MaxCapacity FROM PlayerInGames WHERE PlayerInGameID=$PlayerInGameID LIMIT 1;");
if (!$PlayerResult)
{
   $_SESSION['pmessage'] = "Error checking for player stats.  Could not buy item.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;
}

$PlayerData = mysqli_fetch_row($PlayerResult);
if (!$PlayerData)
{
   $_SESSION['pmessage'] = "Error 2 checking for player stats.  Could not buy item.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;
}

$Cash = $PlayerData[0];
$Color = $PlayerData[1];
$MinCapacity = $PlayerData[2];
$MaxCapacity = $PlayerData[3]; 

if ($Cash < $TotalCost)
{
  $_SESSION['pmessage'] = "Sorry, you do not have enough money!  It costs \$$TotalCost to build there but you only have \$$Cash.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;
}

// ok, so let's get the capacity of the plant we are going to build
$PlantResult = mysqli_query($con, "SELECT GameData.CoalCapacity, GameData.GasCapacity, GameData.NukeCapacity, GameData.WindCapacity, GameData.SolarCapacity FROM GameData INNER JOIN Games WHERE GameData.GameDataID=Games.GameDataID AND Games.GameID=$GameID;");
if (!$PlantResult)
{
   //echo "SELECT GameData.CoalCapacity, GameData.GasCapacity, GameData.NukeCapacity, GameData.WindCapacity, GameData.SolarCapacity FROM GameData INNER JOIN Games WHERE GameData.GameDataID=Games.GameDataID AND Games.GameID=$GameID;";
   
   //$_SESSION['pmessage'] = "Error checking for plant data 3, could not buy item.  SELECT GameData.CoalCapacity, GameData.GasCapacity, GameData.NukeCapacity, GameData.WindCapacity, GameData.SolarCapacity FROM GameData INNER JOIN Games WHERE GameData.GameDataID=Games.GameDataID AND Games.GameID=$GameID;";
   $_SESSION['pmessage'] = "Could not buy item... too expensive?"; // not sure why the previous trap is not fired!
   $_SESSION['pmessagetype'] = 1; 
   $con->close();   
   header("location: play.php?GameID=$GameID");
   die;
}
$PlantData = mysqli_fetch_row($PlantResult);
if (!$PlantData)
{
   //echo "XX SELECT GameData.CoalCapacity, GameData.GasCapacity, GameData.NukeCapacity, GameData.WindCapacity, GameData.SolarCapacity FROM GameData INNER JOIN Games WHERE GameData.GameDataID=Games.GameDataID AND Games.GameID=$GameID;";
   
   $_SESSION['pmessage'] = "Error checking for plant data2 , could not buy item.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();  
   header("location: play.php?GameID=$GameID");
   die;
}

$BuyMaxCapacity = $PlantData[$Type-1];
if ($Type==1 or $Type==3)
{
  $BuyMinCapacity = $BuyMaxCapacity;
}
else
{
  $BuyMinCapacity = 0;
}
    
// PONTENTIAL RACE CONDITION BEGINS HERE

// safety: validate that the space is still available
$result = mysqli_query($con, "SELECT PowerPlantID FROM PowerPlants WHERE X=$X AND Y=$Y AND GameID=$GameID;");
if (!$result)
{
   $_SESSION['pmessage'] = "Error checking for duplicates, could not buy item.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;
}

if ($result->num_rows > 0)
{
   $_SESSION['pmessage'] = "Uh oh!  It looks like someone built there just before you did!  Try building on a different square.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");   
   die;  
}




// all safe at this point, buy it!
$result = mysqli_query($con, "INSERT INTO PowerPlants (PlayerInGameID, Type, MaxCapacity, X, Y, Color, GameID) VALUES ($PlayerInGameID, $Type, $BuyMaxCapacity,$X, $Y, $Color, $GameID);");

// PONTENTIAL RACE CONDITION ENDS

if (!$result)
{   
   $_SESSION['pmessage'] = "Unspecified error buying the item!";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;
}

// update your min and max capacity
$NewCash = $Cash-$TotalCost;
$NewMin = $BuyMinCapacity+$MinCapacity;
$NewMax = $BuyMaxCapacity+$MaxCapacity;
$PlayerResult = mysqli_query($con, "UPDATE PlayerInGames SET Cash=$NewCash, MinCapacity=$NewMin, MaxCapacity=$NewMax WHERE PlayerInGameID=$PlayerInGameID;");
if (!$PlayerResult)
{   
   $_SESSION['pmessage'] = "Unspecified error... the plant was not built.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");
   die;
}

// now check to see if your bid existing bid has an amount lower than the new minimum capacity 
//


// verify that the user has not yet placed a bid this turn          (assert: this should never happen, but hey)
$CheckData = mysqli_query($con, "SELECT BidID, Amount, Rate FROM Bids WHERE TurnHistoryID=$TurnHistoryID AND PlayerInGameID=$PlayerInGameID;");
if (!$CheckData)
{
   $_SESSION['pmessage'] = "Error checking for the existing bids.";
   $_SESSION['pmessagetype'] = 1; 
   $con->close();
   header("location: play.php?GameID=$GameID");   
   die;  
}

// if there is an existing bid
if ($CheckDataRow = mysqli_fetch_row($CheckData))
{
  $BidID = $CheckDataRow[0]; 
  $Amount = $CheckDataRow[1];
  $Rate = $CheckDataRow[2]; 
  // if it is too small, update the bid
  if ($Amount < $NewMin)
  {
    $UpdateBidResult = mysqli_query($con, "UPDATE Bids SET Amount=$NewMin WHERE BidID=$BidID;");
    if (!$UpdateBidResult)
    {  
      $_SESSION['pmessage'] = "Your power plant has been purchased! However, you have an existing bid which may be too small.  You may want to change it.";
      $_SESSION['pmessagetype'] = 0; 
      $con->close();
      header("location: play.php?GameID=$GameID");
      die;
    }  
  
    $_SESSION['pmessage'] = "Your power plant has been purchased! Since your current bid is now below your minimum, it has been increased to a new minumum amount of $Amount at the same rate of $.";
    $_SESSION['pmessagetype'] = 0; 
    $con->close();
    header("location: play.php?GameID=$GameID");
    die;

  }
    
}



$_SESSION['pmessage'] = "Your power plant has been purchased! If you have already placed a bid, you may want to change it.";
$_SESSION['pmessagetype'] = 0; 
$con->close();
header("location: play.php?GameID=$GameID");





?>