<?php

include_once("validategm.php");
include_once("dbconnect.php");


// get post variables
$GameTitle = $_POST['GameTitle'];
$gmid = $_POST['gmid'];
$MaxTurns = $_POST['MaxTurns'];
$MaxPlayers = $_POST['MaxPlayers'];
$StartTime = $_POST['StartTime'];
$GameDataID = $_POST['GameType'];
$MapID = $_POST['MapID'];
$GameDate = '2014-06-06'; // temp;

// create the game index
$result = mysqli_query($con, "INSERT INTO Games (GMID, Status, Turn, MaxTurns, MapID, Date, Time, GameDataID, GameTitle, MaxPlayers, StartTime) VALUES ($gmid, 0, 0, $MaxTurns, $MapID, '$GameDate', $StartTime, $GameDataID, '$GameTitle', $MaxPlayers, $StartTime);");
if (!$result)
{
  $con->close();
  $msg = "Error 1, could not create game!  Query was: " . "INSERT INTO Games (GMID, Status, Turn, MaxTurns, MapID, Date, Time, GameDataID, GameTitle, MaxPlayers, StartTime) VALUES ($gmid, 0, 0, $MaxTurns, $MapID, '$GameDate', $StartTime, $GameDataID, '$GameTitle', $MaxPlayers, $StartTime);";
  echo $msg;
  $_SESSION['gmmessage'] = $msg;
  $_SESSION['gmmessagetype'] = 0;  
  header("location: gmlobby.php");
  die;

}

$GameID = mysqli_insert_id($con);

// now create the weather stations and such
$mainstations = mysqli_query($con, "SELECT WeatherStationID, X, Y, Name FROM WeatherStations WHERE MapID=$MapID;");
while ($mainstationsrow = mysqli_fetch_row($mainstations))
{
  $wid = $mainstationsrow[0];
  
  // then use the random mutation method to adjust itt (between zero and 1))
  $Random1 = round(mt_rand()/mt_getrandmax(),1);
  $Random2 = round(mt_rand()/mt_getrandmax(),1);
  
  $result = mysqli_query($con, "INSERT INTO WeatherStationsInGames (WeatherStationID, GameID, Wind, Sun) VALUES ($wid, $GameID, $Random1, $Random2);");
}



// given the time, day of week, season, and baseload, generate demand going forward
$time = $StartTime;


// get the average demand from the game data
$gamedatarecord = mysqli_query($con, "SELECT AvgDemand FROM GameData WHERE GameDataID=$GameDataID;");
if ($gamedatarow = mysqli_fetch_row($gamedatarecord))
{
  $MeanDemand = $gamedatarow[0];
}
else
{
  // eventually this will be changed.  For now, simple sin wave with some randomness
  $MeanDemand = 10000; // MW
}

$Amplitude = 0.35 * $MeanDemand;

$PeakHr = 16;

$pi_12 = 0.261799388;

$Pred = array_fill(0, 24, 0);

for ($i=0; $i<24; $i++)
{
  $Pred[$i] = round($MeanDemand + $Amplitude * cos($pi_12 * ($time + $i - $PeakHr)) * (1+(mt_rand()/mt_getrandmax()-0.5)*0.1 ) ) ;  
}


$query = "INSERT INTO DemandForecast (GameID";
for ($i=0; $i<24; $i++)
{
  $m = $i+1;
  $query = $query . ", S$m";   
}

$query = $query . ") VALUES ($GameID";
for ($i=0; $i<24; $i++)
{
  $query = $query . ", " . $Pred[$i];   
}

 $query = $query . ");";


$result = mysqli_query($con, $query);



// send back to the manager

$con->close();
$_SESSION['gmmessage'] = "The game has been created!";
$_SESSION['gmmessagetype'] = 0;  
header("location: gmlobby.php");

?>