<?php

function DrawPowerDemand($GameTime, $GameID, $con)
{

  // get all projections, and find the maximum and minimum while you are getting the data
  $DemandForecast = mysqli_query($con, "SELECT S1, S2, S3, S4, S5, S6, S7, S8, S9, S10, S11, S12, S13, S14, S15, S16, S17, S18, S19, S20, S21, S22, S23, S24 FROM DemandForecast WHERE GameID=$GameID;");
  if (!$DemandForecast) 
  { 
    // die quetly
    return;
  }
  
  $Demand = mysqli_fetch_row($DemandForecast);
  if (!$Demand)
  { 
    // die quietly
    return;
  }
  
  $Forecast = array_fill(0, 24, 0);
  $MaxDemand = $Demand[0];
  $MinDemand = $Demand[1];
  for ($i=0;$i<24;$i++)
  {
     $Forecast[$i] = $Demand[$i];
      
     if ($Forecast[$i] > $MaxDemand)
     { 
       $MaxDemand =$Forecast[$i]; 
     }
     //elseif ($Forecast[$i] < $MinDemand)  // keep for the future
     //{ 
//       $MinDemand =$Forecast[$i]; 
//     }
  }
      
  // set the upper bound to the maximum rounded up to th enearest 1000 MW
  $MaxDemand = ceil($MaxDemand / 1000) * 1000;
  
  if ($MaxDemand <= 0)
  {
    // die quietly
    return ; 
  }
  
  
  // get all projections, and find the maximum and minimum while you are getting the data
  $result = mysqli_query($con, "SELECT StartTime FROM Games WHERE GameID=$GameID;");
  if (!$result) 
  { 
    // die quetly
    return;
  }
  
  $StartTimeRow = mysqli_fetch_row($result);
  if (!$StartTimeRow)
  { 
    // die quietly
    return;
  }
  
  
  $StartTime = $StartTimeRow[0];  
  
    // set the lower bound to zero for now
  $MinDemand = 0; 
  
  $PlotHeight = 200;
  
                                  // 17 pixels per element
  echo "<DIV CLASS='full'>";
  
  for ($i=0;$i<24;$i++)
  {
    echo "<DIV CLASS='BarArea' style='height: " . $PlotHeight . "px;'>";
    
    $BarHeight = round($PlotHeight * ($Forecast[$i] / $MaxDemand));
    $BarNoneHeight = $PlotHeight - $BarHeight; 
    
    echo "<DIV CLASS='BarNone'  style='height: " . $BarNoneHeight . "px;'></DIV>";
    
    if (($i+$StartTime)%24==$GameTime)
    {
      echo "<DIV CLASS='BarCurrent'  style='height: " . $BarHeight . "px;'>";
    }
    else
    {
      echo "<DIV CLASS='Bar'  style='height: " . $BarHeight . "px;'>";
    }
    echo "<DIV CLASS='Rotate'>" . $Forecast[$i] . "</DIV></DIV>";
    
    echo "</DIV>";
  }
  
  echo "</DIV>";
  
  $t = $StartTime;
  
  echo "<DIV CLASS='full'>";
  for ($i=0;$i<24;$i++)
  {
    $dt = $t + $i;
    
    if ($dt >= 24)
    {
      $dt = $dt - 24;
    }
    
    if ($dt==0)
    {
      $dt = "M";
    }
    elseif ($dt < 10)
    {
      $dt = $dt."a";
    }
    elseif ($dt<12)
    { 
    
     //no change
    }
    elseif ($dt==12)
    {
      $dt = "N";
    }
    elseif ($dt<=23)
    {
      $dt = $dt - 12;
      if ($dt<10)
      {
        $dt = $dt . "p";
      }
    }
           
    echo "<DIV CLASS='BarXLabel'>$dt</DIV>";     
  }
    
  echo "</DIV>";
  
  
    
  
   

}

?>