<?php

function GenerateWeather($GameID, $con, $reset=0)
{
   // get the current weather for each station
   $result = mysqli_query($con, "SELECT WeatherStationsInGamesID, Wind, Sun FROM WeatherStationsInGames WHERE GameID=$GameID;");
   
   if (!result) 
   {
     return;
   }
      
   while ($row = mysqli_fetch_row($result))
   {
      
           
     // then use the random mutation method to adjust itt (between zero and 1))
     $Random1 = mt_rand()/mt_getrandmax();
     $Random2 = mt_rand()/mt_getrandmax();
     $Random3 = mt_rand()/mt_getrandmax();
     
     // 
     $id = $row[0];
     
     if ($reset or $Random3 <= 0.23)      // totally reset the weather about once per four or five turns
     {
       $newwind = round($Random1,1);
       $newsun = round($Random2,1);
     }
     else
     { 
       $oldwind = $row[1];
       $oldsun = $row[2];
       $newwind = round($Random1 * 0.5 + 0.5*$oldwind,1);
       $newsun = round($Random2 * 0.5 + 0.5*$oldsun,1);
     }
               
       
    
     
     $update = mysqli_query($con, "UPDATE WeatherStationsInGames SET Wind=$newwind, Sun=$newsun WHERE WeatherStationsInGamesID=$id;");
     
     
   }
    
}

?>