<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
	<HEAD>
		<TITLE>Blackout: Watch an Existing Game</TITLE>
		<META NAME="keywords" CONTENT="Blackout Eduational Video Game Sustainability Energy Power Systems">
		<META NAME="description" CONTENT="Blackout: Classroom Edition ">
		<META NAME="rating" CONTENT="general">
		<META NAME="Copyright" CONTENT="(C) 2014 McMaster University">
		<META NAME="Robots" CONTENT="all">
		<META NAME="Authors" CONTENT="Thomas A. Adams II">
		<LINK REL="stylesheet" HREF="css/title.css" TYPE="text/css">		
	</HEAD>
  <BODY>
  
  <?php include_once("dbconnect.php"); ?>
  
  <!-- Main Area -->
  <DIV ID='main'>
    
    <!-- Title -->
    <DIV ID='title'>
    
      <DIV class='titletext'>Blackout!</DIV>
      <DIV class='titlesubtext'>Classroom Edition</DIV>
    
    </DIV>
    
    <DIV ID="gameselecttop">
      <FORM ACTION='index.php' method='post' enctype='multipart/form-data'>
      <INPUT TYPE='submit' NAME='home' VALUE='Home' Class='small'>
      </FORM>
    </DIV>
    
    <DIV class="gameselectwindow">
    <DIV class="gameselectwindowheader">
      Games in Progress
    </DIV>
    <DIV class="gameselectwindowcontent">
      <table class='gameselect'>
      <tr>
      <th class='gameselect'>GameID</Th>
      <th class='gameselect'>Name</Th>
      <th class='gameselect'>Players</Th>
      <th class='gameselect'>(Max)</Th>
      <th colspan=3 class='gameselect'>Map</th>
      
      </tr>
      
      <?php
      
      // find each game in forming
      
      $gamesinprogress = mysqli_query($con, "SELECT Games.GameID, Games.GameTitle, Games.MaxPlayers, Maps.MapName, Maps.PreviewURL FROM Games INNER JOIN Maps on Games.MapID=Maps.MapID WHERE Games.Status=1 ORDER BY Games.GameID ASC;");
      if (!$gamesinprogress)
      {
        echo "<TR><TD COLSPAN=7><i>No games forming</i></TD></TR>";
      }
      else
      {
        
        while ($row=mysqli_fetch_row($gamesinprogress))
        {        
        
          // find how many players are in this game
          $GameID = $row[0];
          $playersingame = mysqli_query($con, "SELECT COUNT(PlayerInGameID) FROM PlayerInGames WHERE GameID=$GameID;");
          if (!$playersingame)
          {
            $numplayers = -2;
          }
          else
          {
            $playersrow = mysqli_fetch_row($playersingame);
            if (!$playersrow)
            {        
              $numplayers = -1;
            }
            else
            {
              $numplayers = $playersrow[0];
            }
          }
          
          
          
                    
          echo "<FORM ACTION='observegame.php' method='get' enctype='multipart/form-data'>";
          echo "<TR><TD>";
          echo $row[0];
          echo "</TD><TD>";
          echo $row[1];
          echo "</TD><TD>";
          echo $numplayers;
          echo "</TD><TD>";
          echo $row[2];
          echo "</TD><TD>";
          echo $row[3];
          echo "</TD><TD><IMG SRC='";
          echo $row[4];
          echo "'></TD><TD><INPUT TYPE='hidden' NAME='GameID' VALUE='";
          echo $row[0]; 
          echo "'><INPUT TYPE='submit' Class='small' value='Watch!'></FORM></TD></TR>";
      
        }
      }
      
      
      ?>
      </table>
      
      
    </DIV>
    </DIV>
    
    
    <DIV class="gameselectwindow">
    <DIV class="gameselectwindowheader">
      Games Now Forming
    </DIV>
    <DIV class="gameselectwindowcontent">
      <table class='gameselect'>
      <tr>
      <th class='gameselect'>GameID</Th>
      <th class='gameselect'>Name</Th>
      <th class='gameselect'>Players</Th>
      <th class='gameselect'>(Max)</Th>
      <th colspan=3 class='gameselect'>Map</th>
      
      </tr>
      
      <?php
      
      // find each game in forming
      
      $gamesforming = mysqli_query($con, "SELECT Games.GameID, Games.GameTitle, Games.MaxPlayers, Maps.MapName, Maps.PreviewURL FROM Games INNER JOIN Maps on Games.MapID=Maps.MapID WHERE Games.Status=0 ORDER BY Games.GameID ASC;");
      if (!$gamesforming)
      {
        echo "<TR><TD COLSPAN=7><i>No games forming</i></TD></TR>";
      }
      else
      {
        
        while ($row=mysqli_fetch_row($gamesforming))
        {        
        
          // find how many players are in this game
          $GameID = $row[0];
          $playersingame = mysqli_query($con, "SELECT COUNT(PlayerInGameID) FROM PlayerInGames WHERE GameID=$GameID;");
          if (!$playersingame)
          {
            $numplayers = -2;
          }
          else
          {
            $playersrow = mysqli_fetch_row($playersingame);
            if (!$playersrow)
            {        
              $numplayers = -1;
            }
            else
            {
              $numplayers = $playersrow[0];
            }
          }
          
          
          
                    
          echo "<FORM ACTION='observegame.php' method='get' enctype='multipart/form-data'>";
          echo "<TR><TD>";
          echo $row[0];
          echo "</TD><TD>";
          echo $row[1];
          echo "</TD><TD>";
          echo $numplayers;
          echo "</TD><TD>";
          echo $row[2];
          echo "</TD><TD>";
          echo $row[3];
          echo "</TD><TD><IMG SRC='";
          echo $row[4];
          echo "'></TD><TD><INPUT TYPE='hidden' NAME='GameID' VALUE='";
          echo $row[0]; 
          echo "'><INPUT TYPE='submit' Class='small' value='Watch!'></FORM></TD></TR>";
      
        }
      }
      
      
      ?>
      </table>
      
    </DIV>
    </DIV>
    
    <!--Footer-->
    <DIV ID='footer'>(c) 2014 McMaster University.  By Thomas A. Adams II and Jake Nease
    </DIV>
    
  </DIV>
  
  
  
  </BODY>
</HTML>
<?php $con->close(); ?>  