<?php
include_once("validateplayer.php");
include_once("dbconnect.php");

if (isset($_POST['GameID']))
{
  // to do: sanitize
  $GameID = $_POST['GameID'];
  $PlayerID = $_SESSION['pid'];
  
  // get all current players  
  
  $PlayersResult = mysqli_query($con, "SELECT PlayerID, Color FROM PlayerInGames WHERE GameID=$GameID ORDER BY Color  ASC;");
  if (!$PlayersResult)
  {
  
    $_SESSION['plogin']=1;
    $_SESSION['pmessage'] = "Problem joining game.  Game not found.";
    $_SESSION['pmessagetype'] = 1;
    $con->close();   
    header("location: playerjoin.php");	  
  }
  
  // get the maximum number of players
  $GamesResult = mysqli_query($con, "SELECT MaxPlayers FROM Games WHERE GameID=$GameID;");
  if (!$GamesResult)
  {
  
    $_SESSION['plogin']=1;
    $_SESSION['pmessage'] = "Problem joining game code 2.  Game not found.";
    $_SESSION['pmessagetype'] = 1;
    $con->close(); 
    header("location: playerjoin.php");	  
  }
  
  // if game is full, say so
  $GamesRow = mysqli_fetch_row($GamesResult);
  if (!$GamesRow)
  {
  
    $_SESSION['plogin']=1;
    $_SESSION['pmessage'] = "Problem joining game code 3.  Game not found.";
    $_SESSION['pmessagetype'] = 1;
    $con->close();
    header("location: playerjoin.php");	  
  }
  
  if (mysqli_num_rows($PlayersResult) >= $GamesRow[0])
  {
  
    $_SESSION['plogin']=1;
    $_SESSION['pmessage'] = "Problem joining game.  No more players allowed.";
    $_SESSION['pmessagetype'] = 1;
    $con->close();  
    header("location: playerjoin.php");	  
  }
  
  
  // go through the list and find the lowest colour number not in the list
  // while you are at it, if the current player is already in the list, then die
  // LAZY LIST!
  
  $Colors = array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20);  
  while ($PlayerRow = mysqli_fetch_row($PlayersResult))
  {
    if ($PlayerRow[0] == $PlayerID)
    {
      $_SESSION['plogin']=1;
      $_SESSION['pmessage'] = "Problem joining game.  You are already in that game!";
      $_SESSION['pmessagetype'] = 1;
      $con->close(); 
      header("location: playerjoin.php");	
    }
    
    // remove this color from the list.
    if (($key = array_search($PlayerRow[1], $Colors)) !== false) 
    {
      unset($Colors[$key]);
    }
              
  }
  
  // assert: user should have a colour number and not be in the list.
  // Add to the game!
  if (isset($_POST['teamname']))
  {
    $TeamName = preg_replace("/[^0-9a-zA-Z_\s!]/", "", substr(trim($_POST['teamname']),0,38));
  }
  else
  {
    $TeamName = "Player $PlayerID";
  }
  
  
  $Col = reset($Colors);
    
  $result = mysqli_query($con, "INSERT INTO PlayerInGames (GameID, PlayerID, TeamName, Color) VALUES ($GameID, $PlayerID, '$TeamName', $Col);");
  if (!$result)
    {
      //echo "INSERT INTO PlayerInGames (GameID, PlayerID, TeamName, Color) VALUES ($GameID, $PlayerID, '$TeamName', $Col);";
      $_SESSION['plogin']=1;
      $_SESSION['pmessage'] = "Could not join game: unspecified reason";
      $_SESSION['pmessagetype'] = 1;
      $con->close();  
      header("location: playerjoin.php");	
    }
  
  
  header("location: play.php?GameID=$GameID");      

  
    
}
else
{
  $_SESSION['plogin']=1;
  $_SESSION['pmessage'] = "Problem joining game.  Unexpected error.";
  $_SESSION['pmessagetype'] = 1;
  $con->close();  
  header("location: playerjoin.php");	 
    
} 

?>